#include "randomizer_check_objects.h"
#include <map>
#include <string>
#include <libultraship/bridge.h>
#include "z64.h"

//            RandomizerCheck,                                                RCVORMQ,         RCTYPE,              RCAREA,                        ActorId,            SceneId,                              ActorParams,                 OG ItemID,           "Short name", "Spoiler name", vanillaCompletion
std::map<RandomizerCheck, RandomizerCheckObject> rcObjects = {
    RC_OBJECT(RC_KF_KOKIRI_SWORD_CHEST,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_KOKIRI_FOREST,                  1248,                        GI_SWORD_KOKIRI,     "Kokiri Sword Chest", "KF Kokiri Sword Chest", true),
    RC_OBJECT(RC_KF_MIDOS_TOP_LEFT_CHEST,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_MIDOS_HOUSE,                    22944,                       GI_RUPEE_BLUE,       "Mido Top Left Chest", "KF Mido Top Left Chest", false),
    RC_OBJECT(RC_KF_MIDOS_TOP_RIGHT_CHEST,                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_MIDOS_HOUSE,                    22945,                       GI_RUPEE_BLUE,       "Mido Top Right Chest", "KF Mido Top Right Chest", false),
    RC_OBJECT(RC_KF_MIDOS_BOTTOM_LEFT_CHEST,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_MIDOS_HOUSE,                    22914,                       GI_RUPEE_GREEN,      "Mido Bottom Left Chest", "KF Mido Bottom Left Chest", false),
    RC_OBJECT(RC_KF_MIDOS_BOTTOM_RIGHT_CHEST,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_MIDOS_HOUSE,                    22787,                       GI_HEART,            "Mido Bottom Right Chest", "KF Mido Bottom Right Chest", false),
    RC_OBJECT(RC_KF_STORMS_GROTTO_CHEST,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_GROTTOS,                        22988,                       GI_RUPEE_RED,        "Storms Grotto Chest", "KF Storms Grotto Chest", false),
    RC_OBJECT(RC_KF_GS_BEAN_PATCH,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KOKIRI_FOREST,          ACTOR_EN_SI,        SCENE_KOKIRI_FOREST,                  27649,                       GI_SKULL_TOKEN,      "GS Bean Patch", "KF GS Bean Patch", true),
    RC_OBJECT(RC_KF_GS_KNOW_IT_ALL_HOUSE,                                     RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KOKIRI_FOREST,          ACTOR_EN_SI,        SCENE_KOKIRI_FOREST,                  19458,                       GI_SKULL_TOKEN,      "GS Know It All House", "KF GS Know It All House", true),
    RC_OBJECT(RC_KF_GS_HOUSE_OF_TWINS,                                        RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KOKIRI_FOREST,          ACTOR_EN_SI,        SCENE_KOKIRI_FOREST,                  19460,                       GI_SKULL_TOKEN,      "GS House of Twins", "KF GS House of Twins", true),
    RC_OBJECT(RC_KF_LINKS_HOUSE_COW,                                          RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_KOKIRI_FOREST,          ACTOR_EN_COW,       SCENE_LINKS_HOUSE,                    0x00,                        GI_MILK,             "Links House Cow", "KF Links House Cow", false),
    RC_OBJECT(RC_KF_SHOP_ITEM_1,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x00,                        GI_SHIELD_DEKU,      "Shop Item 1", "KF Shop Item 1", true),
    RC_OBJECT(RC_KF_SHOP_ITEM_2,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x01,                        GI_NUTS_5_2,         "Shop Item 2", "KF Shop Item 2", false),
    RC_OBJECT(RC_KF_SHOP_ITEM_3,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x02,                        GI_NUTS_10,          "Shop Item 3", "KF Shop Item 3", false),
    RC_OBJECT(RC_KF_SHOP_ITEM_4,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x03,                        GI_STICKS_1,         "Shop Item 4", "KF Shop Item 4", false),
    RC_OBJECT(RC_KF_SHOP_ITEM_5,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x04,                        GI_SEEDS_30,         "Shop Item 5", "KF Shop Item 5", false),
    RC_OBJECT(RC_KF_SHOP_ITEM_6,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x05,                        GI_ARROWS_SMALL,     "Shop Item 6", "KF Shop Item 6", false),
    RC_OBJECT(RC_KF_SHOP_ITEM_7,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x06,                        GI_ARROWS_MEDIUM,    "Shop Item 7", "KF Shop Item 7", false),
    RC_OBJECT(RC_KF_SHOP_ITEM_8,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x07,                        GI_HEART,            "Shop Item 8", "KF Shop Item 8", false),
    RC_OBJECT(RC_KF_DEKU_TREE_LEFT_GOSSIP_STONE,                              RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_KOKIRI_FOREST,          ACTOR_EN_GS,        SCENE_KOKIRI_FOREST,                  14623,                       GI_NONE,             "Deku Tree Left Gossip Stone", "KF Deku Tree Left Gossip Stone", false),
    RC_OBJECT(RC_KF_DEKU_TREE_RIGHT_GOSSIP_STONE,                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_KOKIRI_FOREST,          ACTOR_EN_GS,        SCENE_KOKIRI_FOREST,                  14880,                       GI_NONE,             "Deku Tree Right Gossip Stone", "KF Deku Tree Right Gossip Stone", false),
    RC_OBJECT(RC_KF_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_KOKIRI_FOREST,          ACTOR_EN_GS,        SCENE_KOKIRI_FOREST,                  14366,                       GI_NONE,             "Gossip Stone", "KF Gossip Stone", false),
    RC_OBJECT(RC_KF_STORMS_GOSSIP_STONE,                                      RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_KOKIRI_FOREST,          ACTOR_EN_GS,        SCENE_GROTTOS,                        -22988,                      GI_NONE,             "Storms Gossip Stone", "KF Storms Gossip Stone", false),

    RC_OBJECT(RC_LW_NEAR_SHORTCUTS_GROTTO_CHEST,                              RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_EN_BOX,       SCENE_GROTTOS,                        22964,                       GI_RUPEE_BLUE,       "Near Shortcuts Grotto Chest", "LW Near Shortcuts Grotto Chest", false),
    RC_OBJECT(RC_LW_SKULL_KID,                                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_LOST_WOODS,                     0x00,                        GI_HEART_PIECE,      "Skull Kid", "LW Skull Kid", true),
    RC_OBJECT(RC_LW_TRADE_COJIRO,                                             RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,  RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_LOST_WOODS,                     0x00,                        GI_ODD_MUSHROOM,     "Trade Cojiro", "LW Trade Cojiro", true),
    RC_OBJECT(RC_LW_TRADE_ODD_POTION,                                         RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,  RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_LOST_WOODS,                     0x00,                        GI_SAW,              "Trade Odd Potion", "LW Trade Odd Potion", true),
    RC_OBJECT(RC_LW_OCARINA_MEMORY_GAME,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_LOST_WOODS,                     0x00,                        GI_HEART_PIECE,      "Ocarina Memory Game", "LW Ocarina Memory Game", true),
    RC_OBJECT(RC_LW_TARGET_IN_WOODS,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_LOST_WOODS,                     0x00,                        GI_NONE,             "Target in Woods", "LW Target in Woods", true),
    RC_OBJECT(RC_LW_DEKU_SCRUB_NEAR_DEKU_THEATER_RIGHT,                       RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_LOST_WOODS,                     0x00,                        GI_NUTS_5_2,         "Deku Scrub Near Deku Theater Right", "LW Deku Scrub Near Deku Theater Right", false),
    RC_OBJECT(RC_LW_DEKU_SCRUB_NEAR_DEKU_THEATER_LEFT,                        RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_LOST_WOODS,                     0x01,                        GI_STICKS_1,         "Deku Scrub Near Deku Theater Left", "LW Deku Scrub Near Deku Theater Left", false),
    RC_OBJECT(RC_LW_DEKU_SCRUB_NEAR_BRIDGE,                                   RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_LOST_WOODS,                     0x09,                        GI_STICK_UPGRADE_20, "Deku Scrub Near Bridge", "LW Deku Scrub Near Bridge", true),
    RC_OBJECT(RC_LW_DEKU_SCRUB_GROTTO_REAR,                                   RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x03,0xF5), GI_SEEDS_30,         "Deku Scrub Grotto Rear", "LW Deku Scrub Grotto Rear", false),
    RC_OBJECT(RC_LW_DEKU_SCRUB_GROTTO_FRONT,                                  RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x0A,0xF5), GI_NUT_UPGRADE_30,   "Deku Scrub Grotto Front", "LW Deku Scrub Grotto Front", true),
    RC_OBJECT(RC_DEKU_THEATER_SKULL_MASK,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_GROTTOS,                        0x00,                        GI_NONE,             "Deku Theater Skull Mask", "Deku Theater Skull Mask", true),
    RC_OBJECT(RC_DEKU_THEATER_MASK_OF_TRUTH,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_GROTTOS,                        0x00,                        GI_NONE,             "Deku Theater Mask of Truth", "Deku Theater Mask of Truth", true),
    RC_OBJECT(RC_LW_GS_BEAN_PATCH_NEAR_BRIDGE,                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LOST_WOODS,             ACTOR_EN_SI,        SCENE_LOST_WOODS,                     27905,                       GI_SKULL_TOKEN,      "GS Bean Patch Near Bridge", "LW GS Bean Patch Near Bridge", true),
    RC_OBJECT(RC_LW_GS_BEAN_PATCH_NEAR_THEATER,                               RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LOST_WOODS,             ACTOR_EN_SI,        SCENE_LOST_WOODS,                     27906,                       GI_SKULL_TOKEN,      "GS Bean Patch Near Theater", "LW GS Bean Patch Near Theater", true),
    RC_OBJECT(RC_LW_GS_ABOVE_THEATER,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LOST_WOODS,             ACTOR_EN_SI,        SCENE_LOST_WOODS,                     19716,                       GI_SKULL_TOKEN,      "GS Above Theater", "LW GS Above Theater", true),
    RC_OBJECT(RC_LW_GIFT_FROM_SARIA,                                          RCVORMQ_BOTH,    RCTYPE_OCARINA,      RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_LOST_WOODS,                     0x00,                        GI_OCARINA_FAIRY,    "Gift From Saria", "LW Gift From Saria", true),
    RC_OBJECT(RC_LW_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LOST_WOODS,             ACTOR_EN_GS,        SCENE_LOST_WOODS,                     14365,                       GI_NONE,             "Gossip Stone", "LW Gossip Stone", false),
    RC_OBJECT(RC_LW_NEAR_SHORTCUTS_GOSSIP_STONE,                              RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LOST_WOODS,             ACTOR_EN_GS,        SCENE_GROTTOS,                        -22964,                      GI_NONE,             "Near Shortcuts Gossip Stone", "LW Near Shortcuts Gossip Stone", false),
    
    RC_OBJECT(RC_SFM_WOLFOS_GROTTO_CHEST,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_BOX,       SCENE_GROTTOS,                        31409,                       GI_RUPEE_PURPLE,     "Wolfos Grotto Chest", "SFM Wolfos Grotto Chest", false),
    RC_OBJECT(RC_SFM_DEKU_SCRUB_GROTTO_REAR,                                  RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x07,0xEE), GI_POTION_RED,       "Deku Scrub Grotto Rear", "SFM Deku Scrub Grotto Rear", false),
    RC_OBJECT(RC_SFM_DEKU_SCRUB_GROTTO_FRONT,                                 RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x08,0xEE), GI_POTION_GREEN,     "Deku Scrub Grotto Front", "SFM Deku Scrub Grotto Front", false),
    RC_OBJECT(RC_SFM_GS,                                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_SI,        SCENE_SACRED_FOREST_MEADOW,           19720,                       GI_SKULL_TOKEN,      "GS", "SFM GS", true),
    RC_OBJECT(RC_SHEIK_IN_FOREST,                                             RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_SACRED_FOREST_MEADOW,   ACTOR_ID_MAX,       SCENE_SACRED_FOREST_MEADOW,           0x00,                        GI_NONE,             "Sheik in Forest", "Sheik in Forest", true),
    RC_OBJECT(RC_SONG_FROM_SARIA,                                             RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_SACRED_FOREST_MEADOW,   ACTOR_ID_MAX,       SCENE_SACRED_FOREST_MEADOW,           0x00,                        GI_NONE,             "Song from Saria", "Song from Saria", true),
    RC_OBJECT(RC_SFM_MAZE_LOWER_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_GS,        SCENE_SACRED_FOREST_MEADOW,           14358,                       GI_NONE,             "Maze Lower Gossip Stone", "SFM Maze Lower Gossip Stone", false),
    RC_OBJECT(RC_SFM_MAZE_UPPER_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_GS,        SCENE_SACRED_FOREST_MEADOW,           14615,                       GI_NONE,             "Maze Upper Gossip Stone", "SFM Maze Upper Gossip Stone", false),
    RC_OBJECT(RC_SFM_SARIA_GOSSIP_STONE,                                      RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_GS,        SCENE_SACRED_FOREST_MEADOW,           14876,                       GI_NONE,             "Saria Gossip Stone", "SFM Saria Gossip Stone", false),


    RC_OBJECT(RC_HF_SOUTHEAST_GROTTO_CHEST,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_HYRULE_FIELD,           ACTOR_EN_BOX,       SCENE_GROTTOS,                        22978,                       GI_RUPEE_RED,        "Southeast Grotto Chest", "HF Southeast Grotto Chest", false),
    RC_OBJECT(RC_HF_OPEN_GROTTO_CHEST,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_HYRULE_FIELD,           ACTOR_EN_BOX,       SCENE_GROTTOS,                        22947,                       GI_RUPEE_BLUE,       "Open Grotto Chest", "HF Open Grotto Chest", false),
    RC_OBJECT(RC_HF_NEAR_MARKET_GROTTO_CHEST,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_HYRULE_FIELD,           ACTOR_EN_BOX,       SCENE_GROTTOS,                        22944,                       GI_RUPEE_BLUE,       "Near Market Grotto Chest", "HF Near Market Grotto Chest", false),
    RC_OBJECT(RC_HF_OCARINA_OF_TIME_ITEM,                                     RCVORMQ_BOTH,    RCTYPE_OCARINA,       RCAREA_HYRULE_FIELD,           ACTOR_ID_MAX,       SCENE_HYRULE_FIELD,                   0x00,                        GI_OCARINA_OOT,      "Ocarina of Time Item", "HF Ocarina of Time Item", true),
    RC_OBJECT(RC_HF_TEKTITE_GROTTO_FREESTANDING_POH,                          RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_HYRULE_FIELD,           ACTOR_EN_ITEM00,    SCENE_GROTTOS,                        262,                         GI_HEART_PIECE,      "Tektite Grotto Freestanding PoH", "HF Tektite Grotto Freestanding PoH", true),
    RC_OBJECT(RC_HF_DEKU_SCRUB_GROTTO,                                        RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_HYRULE_FIELD,           ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x02,0xE6), GI_HEART_PIECE,      "Deku Scrub Grotto", "HF Deku Scrub Grotto", true),
    RC_OBJECT(RC_HF_GS_COW_GROTTO,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_HYRULE_FIELD,           ACTOR_EN_SI,        SCENE_GROTTOS,                        10753,                       GI_SKULL_TOKEN,      "GS Cow Grotto", "HF GS Cow Grotto", true),
    RC_OBJECT(RC_HF_GS_NEAR_KAK_GROTTO,                                       RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_HYRULE_FIELD,           ACTOR_EN_SI,        SCENE_GROTTOS,                        10754,                       GI_SKULL_TOKEN,      "GS Near Kak Grotto", "HF GS Near Kak Grotto", true),
    RC_OBJECT(RC_SONG_FROM_OCARINA_OF_TIME,                                   RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_HYRULE_FIELD,           ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Ocarina of Time", "Song from Ocarina of Time", true),
    RC_OBJECT(RC_HF_COW_GROTTO_COW,                                           RCVORMQ_BOTH,    RCTYPE_COW,           RCAREA_HYRULE_FIELD,           ACTOR_EN_COW,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(3485,-291), GI_MILK,             "Cow Grotto Cow", "HF Cow Grotto Cow", false),
    RC_OBJECT(RC_HF_COW_GROTTO_GOSSIP_STONE,                                  RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_HYRULE_FIELD,           ACTOR_EN_GS,        SCENE_GROTTOS,                        14363,                       GI_NONE,             "Cow Grotto Gossip Stone", "HF Cow Grotto Gossip Stone", false),
    RC_OBJECT(RC_HF_NEAR_MARKET_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_HYRULE_FIELD,           ACTOR_EN_GS,        SCENE_GROTTOS,                        -22944,                      GI_NONE,             "Near Market Gossip Stone", "HF Near Market Gossip Stone", false),
    RC_OBJECT(RC_HF_OPEN_GROTTO_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_HYRULE_FIELD,           ACTOR_EN_GS,        SCENE_GROTTOS,                        -22947,                      GI_NONE,             "Open Grotto Gossip Stone", "HF Open Grotto Gossip Stone", false),
    RC_OBJECT(RC_HF_SOUTHEAST_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_HYRULE_FIELD,           ACTOR_EN_GS,        SCENE_GROTTOS,                        -22978,                      GI_NONE,             "Southeast Gossip Stone", "HF Southeast Gossip Stone", false),

    RC_OBJECT(RC_LH_CHILD_FISHING,                                            RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_FISHING_POND,                   0x00,                        GI_HEART_PIECE,      "Child Fishing", "LH Child Fishing", true),
    RC_OBJECT(RC_LH_ADULT_FISHING,                                            RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_FISHING_POND,                   0x00,                        GI_SCALE_GOLD,       "Adult Fishing", "LH Adult Fishing", true),
    RC_OBJECT(RC_LH_LAB_DIVE,                                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_LAKESIDE_LABORATORY,            0x00,                        GI_HEART_PIECE,      "Lab Dive", "LH Lab Dive", true),
    RC_OBJECT(RC_LH_TRADE_FROG,                                               RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,  RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_LAKESIDE_LABORATORY,            0x00,                        GI_FROG,             "Lab Trade Eyeball Frog", "LH Lab Trade Eyeball Frog", true),
    RC_OBJECT(RC_LH_UNDERWATER_ITEM,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_LAKE_HYLIA,                     0x00,                        GI_LETTER_RUTO,      "Underwater Item", "LH Underwater Item", true),
    RC_OBJECT(RC_LH_SUN,                                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_LAKE_HYLIA,                     0x00,                        GI_ARROW_FIRE,       "Sun", "LH Sun", true),
    RC_OBJECT(RC_LH_FREESTANDING_POH,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_EN_ITEM00,    SCENE_LAKE_HYLIA,                     7686,                        GI_HEART_PIECE,      "Freestanding PoH", "LH Freestanding PoH", true),
    RC_OBJECT(RC_LH_DEKU_SCRUB_GROTTO_LEFT,                                   RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_LAKE_HYLIA,             ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x00,0xEF), GI_NUTS_5_2,         "Deku Scrub Grotto Left", "LH Deku Scrub Grotto Left", false),
    RC_OBJECT(RC_LH_DEKU_SCRUB_GROTTO_RIGHT,                                  RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_LAKE_HYLIA,             ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x05,0xEF), GI_BOMBS_5,          "Deku Scrub Grotto Right", "LH Deku Scrub Grotto Right", false),
    RC_OBJECT(RC_LH_DEKU_SCRUB_GROTTO_CENTER,                                 RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_LAKE_HYLIA,             ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x03,0xEF), GI_SEEDS_30,         "Deku Scrub Grotto Center", "LH Deku Scrub Grotto Center", false),
    RC_OBJECT(RC_LH_GS_BEAN_PATCH,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_LAKE_HYLIA,                     29185,                       GI_SKULL_TOKEN,      "GS Bean Patch", "LH GS Bean Patch", true),
    RC_OBJECT(RC_LH_GS_SMALL_ISLAND,                                          RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_LAKE_HYLIA,                     20994,                       GI_SKULL_TOKEN,      "GS Small Island", "LH GS Small Island", true),
    RC_OBJECT(RC_LH_GS_LAB_WALL,                                              RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_LAKE_HYLIA,                     20996,                       GI_SKULL_TOKEN,      "GS Lab Wall", "LH GS Lab Wall", true),
    RC_OBJECT(RC_LH_GS_LAB_CRATE,                                             RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_LAKESIDE_LABORATORY,            -28152,                      GI_SKULL_TOKEN,      "GS Lab Crate", "LH GS Lab Crate", true),
    RC_OBJECT(RC_LH_GS_TREE,                                                  RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_LAKE_HYLIA,                     21008,                       GI_SKULL_TOKEN,      "GS Tree", "LH GS Tree", true),
    RC_OBJECT(RC_LH_LAB_GOSSIP_STONE,                                         RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LAKE_HYLIA,             ACTOR_EN_GS,        SCENE_LAKE_HYLIA,                     14339,                       GI_NONE,             "Lab Gossip Stone", "LH Lab Gossip Stone", false),
    RC_OBJECT(RC_LH_SOUTHEAST_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LAKE_HYLIA,             ACTOR_EN_GS,        SCENE_LAKE_HYLIA,                     14863,                       GI_NONE,             "Southeast Gossip Stone", "LH Southeast Gossip Stone", false),
    RC_OBJECT(RC_LH_SOUTHWEST_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LAKE_HYLIA,             ACTOR_EN_GS,        SCENE_LAKE_HYLIA,                     14600,                       GI_NONE,             "Southwest Gossip Stone", "LH Southwest Gossip Stone", false),

    RC_OBJECT(RC_GV_CHEST,                                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_VALLEY,          ACTOR_EN_BOX,       SCENE_GERUDO_VALLEY,                  23200,                       GI_RUPEE_PURPLE,     "Chest", "GV Chest", false),
    RC_OBJECT(RC_GV_TRADE_SAW,                                                RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,  RCAREA_GERUDO_VALLEY,          ACTOR_ID_MAX,       SCENE_GERUDO_VALLEY,                  0x00,                        GI_NONE,             "Trade Saw", "GV Trade Saw", true),
    RC_OBJECT(RC_GV_WATERFALL_FREESTANDING_POH,                               RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_VALLEY,          ACTOR_EN_ITEM00,    SCENE_GERUDO_VALLEY,                  262,                         GI_HEART_PIECE,      "Waterfall Freestanding PoH", "GV Waterfall Freestanding PoH", true),
    RC_OBJECT(RC_GV_CRATE_FREESTANDING_POH,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_VALLEY,          ACTOR_EN_ITEM00,    SCENE_GERUDO_VALLEY,                  518,                         GI_HEART_PIECE,      "Crate Freestanding PoH", "GV Crate Freestanding PoH", true),
    RC_OBJECT(RC_GV_DEKU_SCRUB_GROTTO_REAR,                                   RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_GERUDO_VALLEY,          ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x07,0xF0), GI_POTION_RED,       "Deku Scrub Grotto Rear", "GV Deku Scrub Grotto Rear", false),
    RC_OBJECT(RC_GV_DEKU_SCRUB_GROTTO_FRONT,                                  RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_GERUDO_VALLEY,          ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x08,0xF0), GI_POTION_GREEN,     "Deku Scrub Grotto Front", "GV Deku Scrub Grotto Front", false),
    RC_OBJECT(RC_GV_GS_BEAN_PATCH,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_VALLEY,          ACTOR_EN_SI,        SCENE_GERUDO_VALLEY,                  29441,                       GI_SKULL_TOKEN,      "GS Bean Patch", "GV GS Bean Patch", true),
    RC_OBJECT(RC_GV_GS_SMALL_BRIDGE,                                          RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_VALLEY,          ACTOR_EN_SI,        SCENE_GERUDO_VALLEY,                  21250,                       GI_SKULL_TOKEN,      "GS Small Bridge", "GV GS Small Bridge", true),
    RC_OBJECT(RC_GV_GS_PILLAR,                                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_VALLEY,          ACTOR_EN_SI,        SCENE_GERUDO_VALLEY,                  21252,                       GI_SKULL_TOKEN,      "GS Pillar", "GV GS Pillar", true),
    RC_OBJECT(RC_GV_GS_BEHIND_TENT,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_VALLEY,          ACTOR_EN_SI,        SCENE_GERUDO_VALLEY,                  21256,                       GI_SKULL_TOKEN,      "GS Behind Tent", "GV GS Behind Tent", true),
    RC_OBJECT(RC_GV_COW,                                                      RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_GERUDO_VALLEY,          ACTOR_EN_COW,       SCENE_GERUDO_VALLEY,                  0x00,                        GI_MILK,             "Cow", "GV Cow", false),
    RC_OBJECT(RC_GV_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_GERUDO_VALLEY,          ACTOR_EN_GS,        SCENE_GERUDO_VALLEY,                  14353,                       GI_NONE,             "Gossip Stone", "GV Gossip Stone", false),

    RC_OBJECT(RC_GF_CHEST,                                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_EN_BOX,       SCENE_GERUDOS_FORTRESS,               1984,                        GI_HEART_PIECE,      "Chest", "GF Chest", true),
    RC_OBJECT(RC_GF_HBA_1000_POINTS,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_ID_MAX,       SCENE_GERUDOS_FORTRESS,               0x00,                        GI_HEART_PIECE,       "GF HBA 1000 Points", "GF HBA 1000 Points", true),
    RC_OBJECT(RC_GF_HBA_1500_POINTS,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_ID_MAX,       SCENE_GERUDOS_FORTRESS,               0x00,                        GI_QUIVER_50,        "GF HBA 1500 Points", "GF HBA 1500 Points", true),
    RC_OBJECT(RC_GF_GERUDO_MEMBERSHIP_CARD,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_ID_MAX,       SCENE_THIEVES_HIDEOUT,                0x00,                        GI_HEART_PIECE,      "GF Gerudo Membership Card", "GF Gerudo Membership Card", true),
    RC_OBJECT(RC_GF_NORTH_F1_CARPENTER,                                       RCVORMQ_BOTH,    RCTYPE_GF_KEY,       RCAREA_GERUDO_FORTRESS,        ACTOR_EN_ITEM00,    SCENE_THIEVES_HIDEOUT,                3089,                        GI_KEY_SMALL,        "GF North F1 Carpenter", "GF North F1 Carpenter", true),
    RC_OBJECT(RC_GF_NORTH_F2_CARPENTER,                                       RCVORMQ_BOTH,    RCTYPE_GF_KEY,       RCAREA_GERUDO_FORTRESS,        ACTOR_EN_ITEM00,    SCENE_THIEVES_HIDEOUT,                2577,                        GI_KEY_SMALL,        "GF North F2 Carpenter", "GF North F2 Carpenter", true),
    RC_OBJECT(RC_GF_SOUTH_F1_CARPENTER,                                       RCVORMQ_BOTH,    RCTYPE_GF_KEY,       RCAREA_GERUDO_FORTRESS,        ACTOR_EN_ITEM00,    SCENE_THIEVES_HIDEOUT,                3601,                        GI_KEY_SMALL,        "GF South F1 Carpenter", "GF South F1 Carpenter", true),
    RC_OBJECT(RC_GF_SOUTH_F2_CARPENTER,                                       RCVORMQ_BOTH,    RCTYPE_GF_KEY,       RCAREA_GERUDO_FORTRESS,        ACTOR_EN_ITEM00,    SCENE_THIEVES_HIDEOUT,                3857,                        GI_KEY_SMALL,        "GF South F2 Carpenter", "GF South F2 Carpenter", true),
    RC_OBJECT(RC_GF_GS_ARCHERY_RANGE,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_FORTRESS,        ACTOR_EN_SI,        SCENE_GERUDOS_FORTRESS,               21505,                       GI_SKULL_TOKEN,      "GS Archery Range", "GF GS Archery Range", true),
    RC_OBJECT(RC_GF_GS_TOP_FLOOR,                                             RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_FORTRESS,        ACTOR_EN_SI,        SCENE_GERUDOS_FORTRESS,               21506,                       GI_SKULL_TOKEN,      "GS Top Floor", "GF GS Top Floor", true),

    RC_OBJECT(RC_WASTELAND_CHEST,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_WASTELAND,              ACTOR_EN_BOX,       SCENE_HAUNTED_WASTELAND,              -30048,                      GI_RUPEE_PURPLE,     "Chest", "Wasteland Chest", false),
    RC_OBJECT(RC_WASTELAND_BOMBCHU_SALESMAN,                                  RCVORMQ_BOTH,    RCTYPE_MERCHANT,     RCAREA_WASTELAND,              ACTOR_ID_MAX,       SCENE_HAUNTED_WASTELAND,              0x00,                        GI_NONE,             "Carpet Salesman", "Wasteland Carpet Salesman", false),
    RC_OBJECT(RC_WASTELAND_GS,                                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_WASTELAND,              ACTOR_EN_SI,        SCENE_HAUNTED_WASTELAND,              13570,                       GI_SKULL_TOKEN,      "GS", "Wasteland GS", true),

    RC_OBJECT(RC_COLOSSUS_FREESTANDING_POH,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_DESERT_COLOSSUS,        ACTOR_EN_ITEM00,    SCENE_DESERT_COLOSSUS,                3334,                        GI_HEART_PIECE,      "Freestanding PoH", "Colossus Freestanding PoH", true),
    RC_OBJECT(RC_COLOSSUS_DEKU_SCRUB_GROTTO_REAR,                             RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_DESERT_COLOSSUS,        ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x07,0xFD), GI_POTION_RED,       "Deku Scrub Grotto Rear", "Colossus Deku Scrub Grotto Rear", false),
    RC_OBJECT(RC_COLOSSUS_DEKU_SCRUB_GROTTO_FRONT,                            RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_DESERT_COLOSSUS,        ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x08,0xFD), GI_POTION_GREEN,     "Deku Scrub Grotto Front", "Colossus Deku Scrub Grotto Front", false),
    RC_OBJECT(RC_COLOSSUS_GS_BEAN_PATCH,                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_DESERT_COLOSSUS,        ACTOR_EN_SI,        SCENE_DESERT_COLOSSUS,                29953,                       GI_SKULL_TOKEN,      "GS Bean Patch", "Colossus GS Bean Patch", true),
    RC_OBJECT(RC_COLOSSUS_GS_HILL,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_DESERT_COLOSSUS,        ACTOR_EN_SI,        SCENE_DESERT_COLOSSUS,                21764,                       GI_SKULL_TOKEN,      "GS Hill", "Colossus GS Hill", true),
    RC_OBJECT(RC_COLOSSUS_GS_TREE,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_DESERT_COLOSSUS,        ACTOR_EN_SI,        SCENE_DESERT_COLOSSUS,                21768,                       GI_SKULL_TOKEN,      "GS Tree", "Colossus GS Tree", true),
    RC_OBJECT(RC_COLOSSUS_GREAT_FAIRY_REWARD,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_DESERT_COLOSSUS,        ACTOR_BG_DY_YOSEIZO,SCENE_GREAT_FAIRYS_FOUNTAIN_SPELLS,   3,                           GI_NONE,             "Great Fairy Reward", "Colossus Great Fairy Reward", true),
    RC_OBJECT(RC_SHEIK_AT_COLOSSUS,                                           RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_DESERT_COLOSSUS,        ACTOR_ID_MAX,       SCENE_DESERT_COLOSSUS,                0x00,                        GI_NONE,             "Sheik at Colossus", "Sheik at Colossus", true),
    RC_OBJECT(RC_COLOSSUS_GOSSIP_STONE,                                       RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_DESERT_COLOSSUS,        ACTOR_EN_GS,        SCENE_DESERT_COLOSSUS,                14362,                       GI_NONE,             "Gossip Stone", "Colossus Gossip Stone", false),

    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_REWARD,                           RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TREASURE_BOX_SHOP,              0x00,                        GI_HEART_PIECE,      "Treasure Chest Game Reward", "MK Treasure Chest Game Reward", true),
    RC_OBJECT(RC_MARKET_BOMBCHU_BOWLING_FIRST_PRIZE,                          RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_BOMBCHU_BOWLING_ALLEY,          0x00,                        GI_NONE,             "Bombchu Bowling First Prize", "MK Bombchu Bowling First Prize", true),
    RC_OBJECT(RC_MARKET_BOMBCHU_BOWLING_SECOND_PRIZE,                         RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_BOMBCHU_BOWLING_ALLEY,          0x00,                        GI_HEART_PIECE,      "Bombchu Bowling Second Prize", "MK Bombchu Bowling Second Prize", true),
    RC_OBJECT(RC_MARKET_LOST_DOG,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_DOG_LADY_HOUSE,                 0x00,                        GI_HEART_PIECE,      "Lost Dog", "MK Lost Dog", true),
    RC_OBJECT(RC_MARKET_SHOOTING_GALLERY_REWARD,                              RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_SHOOTING_GALLERY,               0x00,                        GI_BULLET_BAG_40,    "Shooting Gallery", "MK Shooting Gallery", true),
    RC_OBJECT(RC_MARKET_10_BIG_POES,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_MARKET_GUARD_HOUSE,             0x00,                        GI_BOTTLE,           "10 Big Poes", "MK 10 Big Poes", true),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_1,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,    RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TREASURE_BOX_SHOP,              0x00,                        GI_NONE,             "Chest Game First Room Chest", "MK Chest Game First Room Chest", false),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_2,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,    RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TREASURE_BOX_SHOP,              0x00,                        GI_NONE,             "Chest Game Second Room Chest", "MK Chest Game Second Room Chest", false),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_3,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,    RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TREASURE_BOX_SHOP,              0x00,                        GI_NONE,             "Chest Game Third Room Chest", "MK Chest Game Third Room Chest", false),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_4,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,    RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TREASURE_BOX_SHOP,              0x00,                        GI_NONE,             "Chest Game Fourth Room Chest", "MK Chest Game Fourth Room Chest", false),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_5,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,    RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TREASURE_BOX_SHOP,              0x00,                        GI_NONE,             "Chest Game Fifth Room Chest", "MK Chest Game Fifth Room Chest", false),
    RC_OBJECT(RC_MARKET_GS_GUARD_HOUSE,                                       RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_MARKET,                 ACTOR_EN_SI,        SCENE_MARKET_GUARD_HOUSE,             -29176,                      GI_SKULL_TOKEN,      "Market GS Guard House", "Market GS Guard House", true),
    RC_OBJECT(RC_TOT_LIGHT_ARROWS_CUTSCENE,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_ARROW_LIGHT,      "ToT Light Arrow Cutscene", "ToT Light Arrow Cutscene", true),
    RC_OBJECT(RC_TOT_MASTER_SWORD,                                            RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Master Sword", "ToT Master Sword", true),
    RC_OBJECT(RC_SHEIK_AT_TEMPLE,                                             RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Sheik at Temple", "Sheik at Temple", true),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_1,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BOMBCHU_SHOP,                   0x00,                        GI_BOMBCHUS_10,      "Bombchu Shop Item 1", "MK Bombchu Shop Item 1", false),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_2,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BOMBCHU_SHOP,                   0x01,                        GI_BOMBCHUS_10,      "Bombchu Shop Item 2", "MK Bombchu Shop Item 2", false),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_3,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BOMBCHU_SHOP,                   0x02,                        GI_BOMBCHUS_10,      "Bombchu Shop Item 3", "MK Bombchu Shop Item 3", false),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_4,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BOMBCHU_SHOP,                   0x03,                        GI_BOMBCHUS_10,      "Bombchu Shop Item 4", "MK Bombchu Shop Item 4", false),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_5,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BOMBCHU_SHOP,                   0x04,                        GI_BOMBCHUS_20,      "Bombchu Shop Item 5", "MK Bombchu Shop Item 5", false),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_6,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BOMBCHU_SHOP,                   0x05,                        GI_BOMBCHUS_20,      "Bombchu Shop Item 6", "MK Bombchu Shop Item 6", false),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_7,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BOMBCHU_SHOP,                   0x06,                        GI_BOMBCHUS_20,      "Bombchu Shop Item 7", "MK Bombchu Shop Item 7", false),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_8,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BOMBCHU_SHOP,                   0x07,                        GI_BOMBCHUS_20,      "Bombchu Shop Item 8", "MK Bombchu Shop Item 8", false),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_1,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_MARKET,             0x00,                        GI_POTION_GREEN,     "Potion Shop Item 1", "MK Potion Shop Item 1", false),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_2,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_MARKET,             0x01,                        GI_BLUE_FIRE,        "Potion Shop Item 2", "MK Potion Shop Item 2", false),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_3,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_MARKET,             0x02,                        GI_POTION_RED,       "Potion Shop Item 3", "MK Potion Shop Item 3", false),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_4,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_MARKET,             0x03,                        GI_FAIRY,            "Potion Shop Item 4", "MK Potion Shop Item 4", false),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_5,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_MARKET,             0x04,                        GI_NUTS_5_2,         "Potion Shop Item 5", "MK Potion Shop Item 5", false),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_6,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_MARKET,             0x05,                        GI_BUGS,             "Potion Shop Item 6", "MK Potion Shop Item 6", false),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_7,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_MARKET,             0x06,                        GI_POE,              "Potion Shop Item 7", "MK Potion Shop Item 7", false),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_8,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_MARKET,             0x07,                        GI_FISH,             "Potion Shop Item 8", "MK Potion Shop Item 8", false),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_1,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BAZAAR,                         0x00,                        GI_SHIELD_HYLIAN,    "Bazaar Item 1", "MK Bazaar Item 1", false),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_2,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BAZAAR,                         0x01,                        GI_BOMBS_5,          "Bazaar Item 2", "MK Bazaar Item 2", false),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_3,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BAZAAR,                         0x02,                        GI_NUTS_5_2,         "Bazaar Item 3", "MK Bazaar Item 3", false),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_4,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BAZAAR,                         0x03,                        GI_HEART,            "Bazaar Item 4", "MK Bazaar Item 4", false),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_5,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BAZAAR,                         0x04,                        GI_ARROWS_SMALL,     "Bazaar Item 5", "MK Bazaar Item 5", false),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_6,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BAZAAR,                         0x05,                        GI_ARROWS_LARGE,     "Bazaar Item 6", "MK Bazaar Item 6", false),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_7,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BAZAAR,                         0x06,                        GI_STICKS_1,         "Bazaar Item 7", "MK Bazaar Item 7", false),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_8,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_BAZAAR,                         0x07,                        GI_ARROWS_MEDIUM,    "Bazaar Item 8", "MK Bazaar Item 8", false),
    RC_OBJECT(RC_TOT_LEFT_CENTER_GOSSIP_STONE,                                RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_MARKET,                 ACTOR_EN_GS,        SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Left Center Gossip Stone", "ToT Left Center Gossip Stone", false),
    RC_OBJECT(RC_TOT_LEFT_GOSSIP_STONE,                                       RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_MARKET,                 ACTOR_EN_GS,        SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Left Gossip Stone", "ToT Left Gossip Stone", false),
    RC_OBJECT(RC_TOT_RIGHT_CENTER_GOSSIP_STONE,                               RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_MARKET,                 ACTOR_EN_GS,        SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Right Center Gossip Stone", "ToT Right Center Gossip Stone", false),
    RC_OBJECT(RC_TOT_RIGHT_GOSSIP_STONE,                                      RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_MARKET,                 ACTOR_EN_GS,        SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Right Gossip Stone", "ToT Right Gossip Stone", false),

    RC_OBJECT(RC_HC_MALON_EGG,                                                RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_HYRULE_CASTLE,          ACTOR_ID_MAX,       SCENE_HYRULE_CASTLE,                  0x00,                        GI_NONE,             "Malon Egg", "HC Malon Egg", true),
    RC_OBJECT(RC_HC_ZELDAS_LETTER,                                            RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_HYRULE_CASTLE,          ACTOR_ID_MAX,       SCENE_CASTLE_COURTYARD_ZELDA,         0x00,                        GI_LETTER_ZELDA,     "Zeldas Letter", "HC Zeldas Letter", true),
    RC_OBJECT(RC_OGC_GS,                                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_HYRULE_CASTLE,          ACTOR_EN_SI,        SCENE_OUTSIDE_GANONS_CASTLE,          11777,                       GI_SKULL_TOKEN,      "OGC GS", "OGC GS", true),
    RC_OBJECT(RC_HC_GS_STORMS_GROTTO,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_HYRULE_CASTLE,          ACTOR_EN_SI,        SCENE_GROTTOS,                        11778,                       GI_SKULL_TOKEN,      "GS Storms Grotto", "HC GS Storms Grotto", true),
    RC_OBJECT(RC_HC_GS_TREE,                                                  RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_HYRULE_CASTLE,          ACTOR_EN_SI,        SCENE_HYRULE_CASTLE,                  -29180,                      GI_SKULL_TOKEN,      "GS Tree", "HC GS Tree", true),
    RC_OBJECT(RC_HC_GREAT_FAIRY_REWARD,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_HYRULE_CASTLE,          ACTOR_BG_DY_YOSEIZO,SCENE_GREAT_FAIRYS_FOUNTAIN_SPELLS,   2,                           GI_MAGIC_SMALL,      "Great Fairy Reward", "HC Great Fairy Reward", true),
    RC_OBJECT(RC_OGC_GREAT_FAIRY_REWARD,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_HYRULE_CASTLE,          ACTOR_BG_DY_YOSEIZO,SCENE_GREAT_FAIRYS_FOUNTAIN_MAGIC,    3,                           GI_NONE,             "OGC Great Fairy Reward", "OGC Great Fairy Reward", true),
    RC_OBJECT(RC_SONG_FROM_IMPA,                                              RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_HYRULE_CASTLE,          ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Impa", "Song from Impa", true),
    RC_OBJECT(RC_HC_MALON_GOSSIP_STONE,                                       RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_HYRULE_CASTLE,          ACTOR_EN_GS,        SCENE_HYRULE_CASTLE,                  14610,                       GI_NONE,             "Malon Gossip Stone", "HC Malon Gossip Stone", false),
    RC_OBJECT(RC_HC_ROCK_WALL_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_HYRULE_CASTLE,          ACTOR_EN_GS,        SCENE_HYRULE_CASTLE,                  14347,                       GI_NONE,             "Rock Wall Gossip Stone", "HC Rock Wall Gossip Stone", false),
    RC_OBJECT(RC_HC_STORMS_GROTTO_GOSSIP_STONE,                               RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_HYRULE_CASTLE,          ACTOR_EN_GS,        SCENE_GROTTOS,                        14355,                       GI_NONE,             "Storms Grotto Gossip Stone", "HC Storms Grotto Gossip Stone", false),

    RC_OBJECT(RC_KAK_REDEAD_GROTTO_CHEST,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_BOX,       SCENE_GROTTOS,                        31434,                       GI_RUPEE_GOLD,       "Redead Grotto Chest", "Kak Redead Grotto Chest", false),
    RC_OBJECT(RC_KAK_OPEN_GROTTO_CHEST,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_BOX,       SCENE_GROTTOS,                        22984,                       GI_RUPEE_RED,        "Open Grotto Chest", "Kak Open Grotto Chest", false),
    RC_OBJECT(RC_KAK_10_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_HOUSE_OF_SKULLTULA,             0x00,                        GI_WALLET_ADULT,     "10 Gold Skulltula Reward", "Kak 10 Gold Skulltula Reward", true),
    RC_OBJECT(RC_KAK_20_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_HOUSE_OF_SKULLTULA,             0x00,                        GI_STONE_OF_AGONY,   "20 Gold Skulltula Reward", "Kak 20 Gold Skulltula Reward", true),
    RC_OBJECT(RC_KAK_30_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_HOUSE_OF_SKULLTULA,             0x00,                        GI_WALLET_GIANT,     "30 Gold Skulltula Reward", "Kak 30 Gold Skulltula Reward", true),
    RC_OBJECT(RC_KAK_40_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_HOUSE_OF_SKULLTULA,             0x00,                        GI_BOMBCHUS_10,      "40 Gold Skulltula Reward", "Kak 40 Gold Skulltula Reward", false),
    RC_OBJECT(RC_KAK_50_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_HOUSE_OF_SKULLTULA,             0x00,                        GI_HEART_PIECE,      "50 Gold Skulltula Reward", "Kak 50 Gold Skulltula Reward", true),
    RC_OBJECT(RC_KAK_100_GOLD_SKULLTULA_REWARD,                               RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_HOUSE_OF_SKULLTULA,             0x00,                        GI_RUPEE_GOLD,       "100 Gold Skulltula Reward", "Kak 100 Gold Skulltula Reward", false),
    RC_OBJECT(RC_KAK_MAN_ON_ROOF,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_KAKARIKO_VILLAGE,               0x00,                        GI_HEART_PIECE,      "Man on Roof", "Kak Man on Roof", true),
    RC_OBJECT(RC_KAK_SHOOTING_GALLERY_REWARD,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_SHOOTING_GALLERY,               0x00,                        GI_NONE,             "Shooting Gallery Reward", "Kak Shooting Gallery Reward", true),
    RC_OBJECT(RC_KAK_TRADE_ODD_MUSHROOM,                                      RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,   RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_POTION_SHOP_GRANNY,             0x00,                        GI_ODD_POTION,       "Trade Odd Mushroom", "Kak Trade Odd Mushroom", true),
    RC_OBJECT(RC_KAK_GRANNYS_SHOP,                                            RCVORMQ_BOTH,    RCTYPE_MERCHANT,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_POTION_SHOP_GRANNY,             0x00,                        GI_POTION_BLUE,      "Granny's Shop", "Kak Granny's Shop", false),
    RC_OBJECT(RC_KAK_ANJU_AS_ADULT,                                           RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,   RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_KAKARIKO_VILLAGE,               0x00,                        GI_POCKET_EGG,       "Anju as Adult", "Kak Anju as Adult", true),
    RC_OBJECT(RC_KAK_ANJU_AS_CHILD,                                           RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_KAKARIKO_VILLAGE,               0x00,                        GI_BOTTLE,           "Anju as Child", "Kak Anju as Child", true),
    RC_OBJECT(RC_KAK_TRADE_POCKET_CUCCO,                                      RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,   RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_KAKARIKO_VILLAGE,               0x00,                        GI_COJIRO,           "Trade Pocket Cucco", "Kak Trade Pocket Cucco", true),
    RC_OBJECT(RC_KAK_IMPAS_HOUSE_FREESTANDING_POH,                            RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_ITEM00,    SCENE_IMPAS_HOUSE,                    262,                         GI_HEART_PIECE,      "Impas House Freestanding PoH", "Kak Impas House Freestanding PoH", true),
    RC_OBJECT(RC_KAK_WINDMILL_FREESTANDING_POH,                               RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_ITEM00,    SCENE_WINDMILL_AND_DAMPES_GRAVE,      262,                         GI_HEART_PIECE,      "Windmill Freestanding PoH", "Kak Windmill Freestanding PoH", true),
    RC_OBJECT(RC_KAK_GS_HOUSE_UNDER_CONSTRUCTION,                             RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_KAKARIKO_VILLAGE,               20488,                       GI_SKULL_TOKEN,      "GS House Under Construction", "Kak GS House Under Construction", true),
    RC_OBJECT(RC_KAK_GS_SKULLTULA_HOUSE,                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_KAKARIKO_VILLAGE,               20496,                       GI_SKULL_TOKEN,      "GS Skulltula House", "Kak GS Skulltula House", true),
    RC_OBJECT(RC_KAK_GS_GUARDS_HOUSE,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_KAKARIKO_VILLAGE,               20482,                       GI_SKULL_TOKEN,      "GS Guards House", "Kak GS Guards House", true),
    RC_OBJECT(RC_KAK_GS_TREE,                                                 RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_KAKARIKO_VILLAGE,               -28640,                      GI_SKULL_TOKEN,      "GS Tree", "Kak GS Tree", true),
    RC_OBJECT(RC_KAK_GS_WATCHTOWER,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_KAKARIKO_VILLAGE,               20484,                       GI_SKULL_TOKEN,      "GS Watchtower", "Kak GS Watchtower", true),
    RC_OBJECT(RC_KAK_GS_ABOVE_IMPAS_HOUSE,                                    RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_KAKARIKO_VILLAGE,               20544,                       GI_SKULL_TOKEN,      "GS Above Impas House", "Kak GS Above Impas House", true),
    RC_OBJECT(RC_SHEIK_IN_KAKARIKO,                                           RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Sheik in Kakariko", "Sheik in Kakariko", true),
    RC_OBJECT(RC_SONG_FROM_WINDMILL,                                          RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Windmill", "Song from Windmill", true),
    RC_OBJECT(RC_KAK_IMPAS_HOUSE_COW,                                         RCVORMQ_BOTH,    RCTYPE_COW,           RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_COW,       SCENE_IMPAS_HOUSE,                    0x00,                        GI_MILK,             "Impas House Cow", "Kak Impas House Cow", false),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_1,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_KAKARIKO,           0x00,                        GI_POTION_GREEN,     "Potion Shop Item 1", "Kak Potion Shop Item 1", false),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_2,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_KAKARIKO,           0x01,                        GI_BLUE_FIRE,        "Potion Shop Item 2", "Kak Potion Shop Item 2", false),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_3,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_KAKARIKO,           0x02,                        GI_POTION_RED,       "Potion Shop Item 3", "Kak Potion Shop Item 3", false),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_4,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_KAKARIKO,           0x03,                        GI_FAIRY,            "Potion Shop Item 4", "Kak Potion Shop Item 4", false),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_5,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_KAKARIKO,           0x04,                        GI_NUTS_5_2,         "Potion Shop Item 5", "Kak Potion Shop Item 5", false),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_6,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_KAKARIKO,           0x05,                        GI_BUGS,             "Potion Shop Item 6", "Kak Potion Shop Item 6", false),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_7,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_KAKARIKO,           0x06,                        GI_POE,              "Potion Shop Item 7", "Kak Potion Shop Item 7", false),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_8,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_POTION_SHOP_KAKARIKO,           0x07,                        GI_FISH,             "Potion Shop Item 8", "Kak Potion Shop Item 8", false),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_1,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x00,                        GI_SHIELD_HYLIAN,    "Bazaar Item 1", "Kak Bazaar Item 1", false),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_2,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x01,                        GI_BOMBS_5,          "Bazaar Item 2", "Kak Bazaar Item 2", false),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_3,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x02,                        GI_NUTS_5_2,         "Bazaar Item 3", "Kak Bazaar Item 3", false),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_4,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x03,                        GI_HEART,            "Bazaar Item 4", "Kak Bazaar Item 4", false),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_5,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x04,                        GI_ARROWS_SMALL,     "Bazaar Item 5", "Kak Bazaar Item 5", false),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_6,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x05,                        GI_ARROWS_LARGE,     "Bazaar Item 6", "Kak Bazaar Item 6", false),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_7,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x06,                        GI_STICKS_1,         "Bazaar Item 7", "Kak Bazaar Item 7", false),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_8,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x07,                        GI_ARROWS_MEDIUM,    "Bazaar Item 8", "Kak Bazaar Item 8", false),
    RC_OBJECT(RC_KAK_OPEN_GROTTO_GOSSIP_STONE,                                RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GS,        SCENE_GROTTOS,                        -22984,                      GI_NONE,             "Open Grotto Gossip Stone", "Kak Open Grotto Gossip Stone", false),

    RC_OBJECT(RC_GRAVEYARD_SHIELD_GRAVE_CHEST,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_GRAVEYARD,              ACTOR_EN_BOX,       SCENE_GRAVE_WITH_FAIRYS_FOUNTAIN,     21824,                       GI_SHIELD_HYLIAN,    "Shield Grave Chest", "GY Shield Grave Chest", false),
    RC_OBJECT(RC_GRAVEYARD_HEART_PIECE_GRAVE_CHEST,                           RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_GRAVEYARD,              ACTOR_EN_BOX,       SCENE_REDEAD_GRAVE,                   -22592,                      GI_HEART_PIECE,      "Heart Piece Grave Chest", "GY Heart Piece Grave Chest", true),
    RC_OBJECT(RC_GRAVEYARD_ROYAL_FAMILYS_TOMB_CHEST,                          RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_GRAVEYARD,              ACTOR_EN_BOX,       SCENE_ROYAL_FAMILYS_TOMB,             -32736,                      GI_BOMBS_5,          "Composers Grave Chest", "GY Composers Grave Chest", false),
    RC_OBJECT(RC_GRAVEYARD_HOOKSHOT_CHEST,                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_GRAVEYARD,              ACTOR_EN_BOX,       SCENE_WINDMILL_AND_DAMPES_GRAVE,      4352,                        GI_HOOKSHOT,         "Hookshot Chest", "GY Hookshot Chest", true),
    RC_OBJECT(RC_GRAVEYARD_DAMPE_RACE_FREESTANDING_POH,                       RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_GRAVEYARD,              ACTOR_EN_ITEM00,    SCENE_WINDMILL_AND_DAMPES_GRAVE,      1798,                        GI_HEART_PIECE,      "Dampe Race Freestanding PoH", "GY Dampe Race Freestanding PoH", true),
    RC_OBJECT(RC_GRAVEYARD_FREESTANDING_POH,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_GRAVEYARD,              ACTOR_EN_ITEM00,    SCENE_GRAVEYARD,                      1030,                        GI_HEART_PIECE,      "Freestanding PoH", "GY Freestanding PoH", true),
    RC_OBJECT(RC_GRAVEYARD_DAMPE_GRAVEDIGGING_TOUR,                           RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_GRAVEYARD,              ACTOR_EN_ITEM00,    SCENE_GRAVEYARD,                      6406,                        GI_HEART_PIECE,      "Dampe Gravedigging Tour", "GY Dampe Gravedigging Tour", true),
    RC_OBJECT(RC_GRAVEYARD_GS_WALL,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_GRAVEYARD,              ACTOR_EN_SI,        SCENE_GRAVEYARD,                      20608,                       GI_SKULL_TOKEN,      "GS Wall", "Graveyard GS Wall", true),
    RC_OBJECT(RC_GRAVEYARD_GS_BEAN_PATCH,                                     RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_GRAVEYARD,              ACTOR_EN_SI,        SCENE_GRAVEYARD,                      28673,                       GI_SKULL_TOKEN,      "GS Bean Patch", "Graveyard GS Bean Patch", true),
    RC_OBJECT(RC_SONG_FROM_ROYAL_FAMILYS_TOMB,                                RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_GRAVEYARD,              ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Composers Grave", "Song from Composers Grave", true),
    RC_OBJECT(RC_GY_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_GRAVEYARD,              ACTOR_EN_GS,        SCENE_GRAVEYARD,                      14346,                       GI_NONE,             "Gossip Stone", "GY Gossip Stone", false),

    RC_OBJECT(RC_DMT_CHEST,                                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_BOX,       SCENE_DEATH_MOUNTAIN_TRAIL,           23201,                       GI_RUPEE_PURPLE,     "Chest", "DMT Chest", false),
    RC_OBJECT(RC_DMT_STORMS_GROTTO_CHEST,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_BOX,       SCENE_GROTTOS,                        23255,                       GI_RUPEE_GOLD,       "Storms Grotto Chest", "DMT Storms Grotto Chest", false),
    RC_OBJECT(RC_DMT_TRADE_BROKEN_SWORD,                                      RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_ID_MAX,       SCENE_DEATH_MOUNTAIN_TRAIL,           0x00,                        GI_NONE,             "Trade Broken Sword", "DMT Trade Broken Sword", true),
    RC_OBJECT(RC_DMT_TRADE_EYEDROPS,                                          RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_ID_MAX,       SCENE_DEATH_MOUNTAIN_TRAIL,           0x00,                        GI_NONE,             "Trade Eyedrops", "DMT Trade Eyedrops", true),
    RC_OBJECT(RC_DMT_TRADE_CLAIM_CHECK,                                       RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_ID_MAX,       SCENE_DEATH_MOUNTAIN_TRAIL,           0x00,                        GI_NONE,             "Trade Claim Check", "DMT Trade Claim Check", true),
    RC_OBJECT(RC_DMT_FREESTANDING_POH,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_ITEM00,    SCENE_DEATH_MOUNTAIN_TRAIL,           7686,                        GI_HEART_PIECE,      "Freestanding PoH", "DMT Freestanding PoH", true),
    RC_OBJECT(RC_DMT_GS_BEAN_PATCH,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_SI,        SCENE_DEATH_MOUNTAIN_TRAIL,           28418,                       GI_SKULL_TOKEN,      "GS Bean Patch", "DMT GS Bean Patch", true),
    RC_OBJECT(RC_DMT_GS_NEAR_KAK,                                             RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_SI,        SCENE_DEATH_MOUNTAIN_TRAIL,           12036,                       GI_SKULL_TOKEN,      "GS Near Kak", "DMT GS Near Kak", true),
    RC_OBJECT(RC_DMT_GS_ABOVE_DODONGOS_CAVERN,                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_SI,        SCENE_DEATH_MOUNTAIN_TRAIL,           20232,                       GI_SKULL_TOKEN,      "GS Above Dodongos Cavern", "DMT GS Above Dodongos Cavern", true),
    RC_OBJECT(RC_DMT_GS_FALLING_ROCKS_PATH,                                   RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_SI,        SCENE_DEATH_MOUNTAIN_TRAIL,           20240,                       GI_SKULL_TOKEN,      "GS Falling Rocks Path", "DMT GS Falling Rocks Path", true),
    RC_OBJECT(RC_DMT_GREAT_FAIRY_REWARD,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_BG_DY_YOSEIZO,SCENE_GREAT_FAIRYS_FOUNTAIN_MAGIC,    1,                           GI_NONE,             "Great Fairy Reward", "DMT Great Fairy Reward", true),
    RC_OBJECT(RC_DMT_COW_GROTTO_COW,                                          RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_COW,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(2444,-471), GI_MILK,             "Cow Grotto Cow", "DMT Cow Grotto Cow", false),
    RC_OBJECT(RC_DMT_GOSSIP_STONE,                                            RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_GS,        SCENE_DEATH_MOUNTAIN_TRAIL,           14340,                       GI_NONE,             "Gossip Stone", "DMT Gossip Stone", false),
    RC_OBJECT(RC_DMT_STORMS_GROTTO_GOSSIP_STONE,                              RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_GS,        SCENE_GROTTOS,                        -23255,                      GI_NONE,             "Storms Grotto Gossip Stone", "DMT Storms Grotto Gossip Stone", false),

    RC_OBJECT(RC_GC_MAZE_LEFT_CHEST,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_BOX,       SCENE_GORON_CITY,                     23232,                       GI_RUPEE_GOLD,       "Maze Left Chest", "GC Maze Left Chest", false),
    RC_OBJECT(RC_GC_MAZE_RIGHT_CHEST,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_BOX,       SCENE_GORON_CITY,                     23201,                       GI_RUPEE_PURPLE,     "Maze Right Chest", "GC Maze Right Chest", false),
    RC_OBJECT(RC_GC_MAZE_CENTER_CHEST,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_BOX,       SCENE_GORON_CITY,                     23202,                       GI_RUPEE_PURPLE,     "Maze Center Chest", "GC Maze Center Chest", false),
    RC_OBJECT(RC_GC_ROLLING_GORON_AS_CHILD,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_ID_MAX,       SCENE_GORON_CITY,                     0x00,                        GI_NONE,             "Rolling Goron as Child", "GC Rolling Goron as Child", true),
    RC_OBJECT(RC_GC_ROLLING_GORON_AS_ADULT,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_ID_MAX,       SCENE_GORON_CITY,                     0x00,                        GI_NONE,             "Rolling Goron as Adult", "GC Rolling Goron as Adult", true),
    RC_OBJECT(RC_GC_DARUNIAS_JOY,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_ID_MAX,       SCENE_GORON_CITY,                     0x00,                        GI_NONE,             "Darunias Joy", "GC Darunias Joy", true),
    RC_OBJECT(RC_GC_POT_FREESTANDING_POH,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_ITEM00,    SCENE_GORON_CITY,                     7942,                        GI_HEART_PIECE,      "Pot Freestanding PoH", "GC Pot Freestanding PoH", true),
    RC_OBJECT(RC_GC_DEKU_SCRUB_GROTTO_LEFT,                                   RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_GORON_CITY,             ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x00,0xFB), GI_NUTS_5_2,         "Deku Scrub Grotto Left", "GC Deku Scrub Grotto Left", false),
    RC_OBJECT(RC_GC_DEKU_SCRUB_GROTTO_RIGHT,                                  RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_GORON_CITY,             ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x05,0xFB), GI_BOMBS_5,          "Deku Scrub Grotto Right", "GC Deku Scrub Grotto Right", false),
    RC_OBJECT(RC_GC_DEKU_SCRUB_GROTTO_CENTER,                                 RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_GORON_CITY,             ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x03,0xFB), GI_SEEDS_30,         "Deku Scrub Grotto Center", "GC Deku Scrub Grotto Center", false),
    RC_OBJECT(RC_GC_MEDIGORON,                                                RCVORMQ_BOTH,    RCTYPE_MERCHANT,     RCAREA_GORON_CITY,             ACTOR_ID_MAX,       SCENE_GORON_CITY,                     0x00,                        GI_NONE,             "Medigoron", "GC Medigoron", false),
    RC_OBJECT(RC_GC_GS_CENTER_PLATFORM,                                       RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GORON_CITY,             ACTOR_EN_SI,        SCENE_GORON_CITY,                     12064,                       GI_SKULL_TOKEN,      "GS Center Platform", "GC GS Center Platform", true),
    RC_OBJECT(RC_GC_GS_BOULDER_MAZE,                                          RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GORON_CITY,             ACTOR_EN_SI,        SCENE_GORON_CITY,                     -28864,                      GI_SKULL_TOKEN,      "GS Boulder Maze", "GC GS Boulder Maze", true),
    RC_OBJECT(RC_GC_SHOP_ITEM_1,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GORON_SHOP,                     0x00,                        GI_BOMBS_5,          "Shop Item 1", "GC Shop Item 1", false),
    RC_OBJECT(RC_GC_SHOP_ITEM_2,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GORON_SHOP,                     0x01,                        GI_BOMBS_10,         "Shop Item 2", "GC Shop Item 2", false),
    RC_OBJECT(RC_GC_SHOP_ITEM_3,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GORON_SHOP,                     0x02,                        GI_BOMBS_20,         "Shop Item 3", "GC Shop Item 3", false),
    RC_OBJECT(RC_GC_SHOP_ITEM_4,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GORON_SHOP,                     0x03,                        GI_BOMBS_30,         "Shop Item 4", "GC Shop Item 4", false),
    RC_OBJECT(RC_GC_SHOP_ITEM_5,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GORON_SHOP,                     0x04,                        GI_TUNIC_GORON,      "Shop Item 5", "GC Shop Item 5", false),
    RC_OBJECT(RC_GC_SHOP_ITEM_6,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GORON_SHOP,                     0x05,                        GI_HEART,            "Shop Item 6", "GC Shop Item 6", false),
    RC_OBJECT(RC_GC_SHOP_ITEM_7,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GORON_SHOP,                     0x06,                        GI_POTION_RED,       "Shop Item 7", "GC Shop Item 7", false),
    RC_OBJECT(RC_GC_SHOP_ITEM_8,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GORON_SHOP,                     0x07,                        GI_HEART,            "Shop Item 8", "GC Shop Item 8", false),
    RC_OBJECT(RC_GC_MAZE_GOSSIP_STONE,                                        RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_GORON_CITY,             ACTOR_EN_GS,        SCENE_GORON_CITY,                     14357,                       GI_NONE,             "Maze Gossip Stone", "GC Maze Gossip Stone", false),
    RC_OBJECT(RC_GC_MEDIGORON_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_GORON_CITY,             ACTOR_EN_GS,        SCENE_GORON_CITY,                     14873,                       GI_NONE,             "Medigoron Gossip Stone", "GC Medigoron Gossip Stone", false),

    RC_OBJECT(RC_DMC_UPPER_GROTTO_CHEST,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_BOX,       SCENE_GROTTOS,                        23802,                       GI_BOMBS_20,         "Upper Grotto Chest", "DMC Upper Grotto Chest", false),
    RC_OBJECT(RC_DMC_WALL_FREESTANDING_POH,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_ITEM00,    SCENE_DEATH_MOUNTAIN_CRATER,          518,                         GI_HEART_PIECE,      "Wall Freestanding PoH", "DMC Wall Freestanding PoH", true),
    RC_OBJECT(RC_DMC_VOLCANO_FREESTANDING_POH,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_ITEM00,    SCENE_DEATH_MOUNTAIN_CRATER,          2054,                        GI_HEART_PIECE,      "Volcano Freestanding PoH", "DMC Volcano Freestanding PoH", true),
    RC_OBJECT(RC_DMC_DEKU_SCRUB,                                              RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_DNS,       SCENE_DEATH_MOUNTAIN_CRATER,          0x05,                        GI_BOMBS_5,          "Deku Scrub", "DMC Deku Scrub", false),
    RC_OBJECT(RC_DMC_DEKU_SCRUB_GROTTO_LEFT,                                  RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x00,0xF9), GI_NUTS_5_2,         "Deku Scrub Grotto Left", "DMC Deku Scrub Grotto Left", false),
    RC_OBJECT(RC_DMC_DEKU_SCRUB_GROTTO_RIGHT,                                 RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x05,0xF9), GI_BOMBS_5,          "Deku Scrub Grotto Right", "DMC Deku Scrub Grotto Right", false),
    RC_OBJECT(RC_DMC_DEKU_SCRUB_GROTTO_CENTER,                                RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x03,0xF9), GI_SEEDS_30,         "Deku Scrub Grotto Center", "DMC Deku Scrub Grotto Center", false),
    RC_OBJECT(RC_DMC_GS_BEAN_PATCH,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_SI,        SCENE_DEATH_MOUNTAIN_CRATER,          28417,                       GI_SKULL_TOKEN,      "GS Bean Patch", "DMC GS Bean Patch", true),
    RC_OBJECT(RC_DMC_GS_CRATE,                                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_SI,        SCENE_DEATH_MOUNTAIN_CRATER,          -28800,                      GI_SKULL_TOKEN,      "GS Crate", "DMC GS Crate", true),
    RC_OBJECT(RC_DMC_GREAT_FAIRY_REWARD,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_BG_DY_YOSEIZO,SCENE_GREAT_FAIRYS_FOUNTAIN_MAGIC,    2,                           GI_NONE,             "Great Fairy Reward", "DMC Great Fairy Reward", true),
    RC_OBJECT(RC_SHEIK_IN_CRATER,                                             RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Sheik in Crater", "Sheik in Crater", true),
    RC_OBJECT(RC_DMC_GOSSIP_STONE,                                            RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_GS,        SCENE_DEATH_MOUNTAIN_CRATER,          14341,                       GI_NONE,             "Gossip Stone", "DMC Gossip Stone", false),
    RC_OBJECT(RC_DMC_UPPER_GROTTO_GOSSIP_STONE,                               RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE,  RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_GS,        SCENE_GROTTOS,                        -23802,                      GI_NONE,             "Upper Grotto Gossip Stone", "DMC Upper Grotto Gossip Stone", false),

    RC_OBJECT(RC_ZR_OPEN_GROTTO_CHEST,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_BOX,       SCENE_GROTTOS,                        22985,                       GI_RUPEE_RED,        "Open Grotto Chest", "ZR Open Grotto Chest", false),
    RC_OBJECT(RC_ZR_MAGIC_BEAN_SALESMAN,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_ID_MAX,       SCENE_ZORAS_RIVER,                    0x00,                        GI_NONE,             "Magic Bean Salesman", "ZR Magic Bean Salesman", true),
    RC_OBJECT(RC_ZR_FROGS_ZELDAS_LULLABY,                                     RCVORMQ_BOTH,    RCTYPE_FROG_SONG,    RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_ZORAS_RIVER,                    0x00,                        GI_NONE,             "Frogs Zelda's Lullaby", "ZR Frogs Zelda's Lullaby", false),
    RC_OBJECT(RC_ZR_FROGS_EPONAS_SONG,                                        RCVORMQ_BOTH,    RCTYPE_FROG_SONG,    RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_ZORAS_RIVER,                    0x00,                        GI_NONE,             "Frogs Epona's Song", "ZR Frogs Epona's Song", false),
    RC_OBJECT(RC_ZR_FROGS_SARIAS_SONG,                                        RCVORMQ_BOTH,    RCTYPE_FROG_SONG,    RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_ZORAS_RIVER,                    0x00,                        GI_NONE,             "Frogs Saria's Song", "ZR Frogs Saria's Song", false),
    RC_OBJECT(RC_ZR_FROGS_SUNS_SONG,                                          RCVORMQ_BOTH,    RCTYPE_FROG_SONG,    RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_ZORAS_RIVER,                    0x00,                        GI_NONE,             "Frogs Sun's Song", "ZR Frogs Sun's Song", false),
    RC_OBJECT(RC_ZR_FROGS_SONG_OF_TIME,                                       RCVORMQ_BOTH,    RCTYPE_FROG_SONG,    RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_ZORAS_RIVER,                    0x00,                        GI_NONE,             "Frogs Song of Time", "ZR Frogs Song of Time", false),
    RC_OBJECT(RC_ZR_FROGS_IN_THE_RAIN,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_ZORAS_RIVER,                    0x00,                        GI_HEART_PIECE,      "Frogs in the Rain", "ZR Frogs in the Rain", true),
    RC_OBJECT(RC_ZR_FROGS_OCARINA_GAME,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_ZORAS_RIVER,                    0x00,                        GI_HEART_PIECE,      "Frogs Ocarina Game", "ZR Frogs Ocarina Game", true),
    RC_OBJECT(RC_ZR_NEAR_OPEN_GROTTO_FREESTANDING_POH,                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_ITEM00,    SCENE_ZORAS_RIVER,                    1030,                        GI_HEART_PIECE,      "Near Open Grotto Freestanding PoH", "ZR Near Open Grotto Freestanding PoH", true),
    RC_OBJECT(RC_ZR_NEAR_DOMAIN_FREESTANDING_POH,                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_ITEM00,    SCENE_ZORAS_RIVER,                    2822,                        GI_HEART_PIECE,      "Near Domain Freestanding PoH", "ZR Near Domain Freestanding PoH", true),
    RC_OBJECT(RC_ZR_DEKU_SCRUB_GROTTO_REAR,                                   RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_ZORAS_RIVER,            ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x07,0xEB), GI_POTION_RED,       "Deku Scrub Grotto Rear", "ZR Deku Scrub Grotto Rear", false),
    RC_OBJECT(RC_ZR_DEKU_SCRUB_GROTTO_FRONT,                                  RCVORMQ_BOTH,    RCTYPE_SCRUB,        RCAREA_ZORAS_RIVER,            ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x08,0xEB), GI_POTION_GREEN,     "Deku Scrub Grotto Front", "ZR Deku Scrub Grotto Front", false),
    RC_OBJECT(RC_ZR_GS_LADDER,                                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_RIVER,            ACTOR_EN_SI,        SCENE_ZORAS_RIVER,                    20737,                       GI_SKULL_TOKEN,      "GS Ladder", "ZR GS Ladder", true),
    RC_OBJECT(RC_ZR_GS_TREE,                                                  RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_RIVER,            ACTOR_EN_SI,        SCENE_ZORAS_RIVER,                    -28414,                      GI_SKULL_TOKEN,      "GS Tree", "ZR GS Tree", true),
    RC_OBJECT(RC_ZR_GS_ABOVE_BRIDGE,                                          RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_RIVER,            ACTOR_EN_SI,        SCENE_ZORAS_RIVER,                    20744,                       GI_SKULL_TOKEN,      "GS Above Bridge", "ZR GS Above Bridge", true),
    RC_OBJECT(RC_ZR_GS_NEAR_RAISED_GROTTOS,                                   RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_RIVER,            ACTOR_EN_SI,        SCENE_ZORAS_RIVER,                    20752,                       GI_SKULL_TOKEN,      "GS Near Raised Grottos", "ZR GS Near Raised Grottos", true),
    RC_OBJECT(RC_ZR_NEAR_DOMAIN_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_RIVER,            ACTOR_EN_GS,        SCENE_ZORAS_RIVER,                    14860,                       GI_NONE,             "Near Domain Gossip Stone", "ZR Near Domain Gossip Stone", false),
    RC_OBJECT(RC_ZR_NEAR_GROTTOS_GOSSIP_STONE,                                RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_RIVER,            ACTOR_EN_GS,        SCENE_ZORAS_RIVER,                    14605,                       GI_NONE,             "Near Grottos Gossip Stone", "ZR Near Grottos Gossip Stone", false),
    RC_OBJECT(RC_ZR_OPEN_GROTTO_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_RIVER,            ACTOR_EN_GS,        SCENE_GROTTOS,                        -22985,                      GI_NONE,             "Open Grotto Gossip Stone", "ZR Open Grotto Gossip Stone", false),

    RC_OBJECT(RC_ZD_CHEST,                                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_DOMAIN,           ACTOR_EN_BOX,       SCENE_ZORAS_DOMAIN,                   -18496,                      GI_HEART_PIECE,      "Chest", "ZD Chest", true),
    RC_OBJECT(RC_ZD_DIVING_MINIGAME,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_DOMAIN,           ACTOR_ID_MAX,       SCENE_ZORAS_DOMAIN,                   0x00,                        GI_NONE,             "Diving Minigame", "ZD Diving Minigame", true),
    RC_OBJECT(RC_ZD_KING_ZORA_THAWED,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_DOMAIN,           ACTOR_ID_MAX,       SCENE_ZORAS_DOMAIN,                   0x00,                        GI_NONE,             "King Zora Thawed", "ZD King Zora Thawed", true),
    RC_OBJECT(RC_ZD_TRADE_PRESCRIPTION,                                       RCVORMQ_BOTH,    RCTYPE_ADULT_TRADE,  RCAREA_ZORAS_DOMAIN,           ACTOR_ID_MAX,       SCENE_ZORAS_DOMAIN,                   0x00,                        GI_NONE,             "Trade Prescription", "ZD Trade Prescription", true),
    RC_OBJECT(RC_ZD_GS_FROZEN_WATERFALL,                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_DOMAIN,           ACTOR_EN_SI,        SCENE_ZORAS_DOMAIN,                   20800,                       GI_SKULL_TOKEN,      "GS Frozen Waterfall", "ZD GS Frozen Waterfall", true),
    RC_OBJECT(RC_ZD_SHOP_ITEM_1,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZORA_SHOP,                      0x00,                        GI_TUNIC_ZORA,       "Shop Item 1", "ZD Shop Item 1", false),
    RC_OBJECT(RC_ZD_SHOP_ITEM_2,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZORA_SHOP,                      0x01,                        GI_ARROWS_SMALL,     "Shop Item 2", "ZD Shop Item 2", false),
    RC_OBJECT(RC_ZD_SHOP_ITEM_3,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZORA_SHOP,                      0x02,                        GI_HEART,            "Shop Item 3", "ZD Shop Item 3", false),
    RC_OBJECT(RC_ZD_SHOP_ITEM_4,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZORA_SHOP,                      0x03,                        GI_ARROWS_MEDIUM,    "Shop Item 4", "ZD Shop Item 4", false),
    RC_OBJECT(RC_ZD_SHOP_ITEM_5,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZORA_SHOP,                      0x04,                        GI_NUTS_5_2,         "Shop Item 5", "ZD Shop Item 5", false),
    RC_OBJECT(RC_ZD_SHOP_ITEM_6,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZORA_SHOP,                      0x05,                        GI_ARROWS_LARGE,     "Shop Item 6", "ZD Shop Item 6", false),
    RC_OBJECT(RC_ZD_SHOP_ITEM_7,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZORA_SHOP,                      0x06,                        GI_FISH,             "Shop Item 7", "ZD Shop Item 7", false),
    RC_OBJECT(RC_ZD_SHOP_ITEM_8,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZORA_SHOP,                      0x07,                        GI_POTION_RED,       "Shop Item 8", "ZD Shop Item 8", false),
    RC_OBJECT(RC_ZD_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GS,        SCENE_ZORAS_DOMAIN,                   14345,                       GI_NONE,             "Gossip Stone", "ZD Gossip Stone", false),

    RC_OBJECT(RC_ZF_ICEBERC_FREESTANDING_POH,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_ITEM00,    SCENE_ZORAS_FOUNTAIN,                 262,                         GI_HEART_PIECE,      "Iceberg Freestanding PoH", "ZF Iceberg Freestanding PoH", true),
    RC_OBJECT(RC_ZF_BOTTOM_FREESTANDING_POH,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_ITEM00,    SCENE_ZORAS_FOUNTAIN,                 5126,                        GI_HEART_PIECE,      "Bottom Freestanding PoH", "ZF Bottom Freestanding PoH", true),
    RC_OBJECT(RC_ZF_GS_ABOVE_THE_LOG,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_SI,        SCENE_ZORAS_FOUNTAIN,                 20740,                       GI_SKULL_TOKEN,      "GS Above The Log", "ZF GS Above The Log", true),
    RC_OBJECT(RC_ZF_GS_HIDDEN_CAVE,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_SI,        SCENE_ZORAS_FOUNTAIN,                 20768,                       GI_SKULL_TOKEN,      "GS Hidden Cave", "ZF GS Hidden Cave", true),
    RC_OBJECT(RC_ZF_GS_TREE,                                                  RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_SI,        SCENE_ZORAS_FOUNTAIN,                 -28288,                      GI_SKULL_TOKEN,      "GS Tree", "ZF GS Tree", true),
    RC_OBJECT(RC_ZF_GREAT_FAIRY_REWARD,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_FOUNTAIN,         ACTOR_BG_DY_YOSEIZO,SCENE_GREAT_FAIRYS_FOUNTAIN_SPELLS,   1,                           GI_NONE,             "Great Fairy Reward", "ZF Great Fairy Reward", true),
    RC_OBJECT(RC_FAIRY_GOSSIP_STONE,                                          RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_GS,        SCENE_ZORAS_FOUNTAIN,                 0x00,                        GI_NONE,             "Fairy Gossip Stone", "Fairy Gossip Stone", false),
    RC_OBJECT(RC_JABU_GOSSIP_STONE,                                           RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_GS,        SCENE_ZORAS_FOUNTAIN,                 0x00,                        GI_NONE,             "Jabu Gossip Stone", "Jabu Gossip Stone", false),

    RC_OBJECT(RC_LLR_TALONS_CHICKENS,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_LON_LON_RANCH,          ACTOR_ID_MAX,       SCENE_LON_LON_BUILDINGS,              0x00,                        GI_NONE,             "Talons Chickens", "LLR Talons Chickens", true),
    RC_OBJECT(RC_LLR_FREESTANDING_POH,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,      RCAREA_LON_LON_RANCH,          ACTOR_EN_ITEM00,    SCENE_LON_LON_BUILDINGS,              262,                         GI_HEART_PIECE,      "Freestanding PoH", "LLR Freestanding PoH", true),
    RC_OBJECT(RC_LLR_DEKU_SCRUB_GROTTO_LEFT,                                  RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_LON_LON_RANCH,          ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x00,0xFC), GI_NUTS_5_2,         "Deku Scrub Grotto Left", "LLR Deku Scrub Grotto Left", false),
    RC_OBJECT(RC_LLR_DEKU_SCRUB_GROTTO_RIGHT,                                 RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_LON_LON_RANCH,          ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x05,0xFC), GI_BOMBS_5,          "Deku Scrub Grotto Right", "LLR Deku Scrub Grotto Right", false),
    RC_OBJECT(RC_LLR_DEKU_SCRUB_GROTTO_CENTER,                                RCVORMQ_BOTH,    RCTYPE_SCRUB,         RCAREA_LON_LON_RANCH,          ACTOR_EN_DNS,       SCENE_GROTTOS,                        TWO_ACTOR_PARAMS(0x03,0xFC), GI_SEEDS_30,         "Deku Scrub Grotto Center", "LLR Deku Scrub Grotto Center", false),
    RC_OBJECT(RC_LLR_GS_BACK_WALL,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_LON_LON_RANCH,          ACTOR_EN_SI,        SCENE_LON_LON_RANCH,                  11009,                       GI_SKULL_TOKEN,      "GS Back Wall", "LLR GS Back Wall", true),
    RC_OBJECT(RC_LLR_GS_RAIN_SHED,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_LON_LON_RANCH,          ACTOR_EN_SI,        SCENE_LON_LON_RANCH,                  11010,                       GI_SKULL_TOKEN,      "GS Rain Shed", "LLR GS Rain Shed", true),
    RC_OBJECT(RC_LLR_GS_HOUSE_WINDOW,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_LON_LON_RANCH,          ACTOR_EN_SI,        SCENE_LON_LON_RANCH,                  11012,                       GI_SKULL_TOKEN,      "GS House Window", "LLR GS House Window", true),
    RC_OBJECT(RC_LLR_GS_TREE,                                                 RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,   RCAREA_LON_LON_RANCH,          ACTOR_EN_SI,        SCENE_LON_LON_RANCH,                  -29944,                      GI_SKULL_TOKEN,      "GS Tree", "LLR GS Tree", true),
    RC_OBJECT(RC_SONG_FROM_MALON,                                             RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION, RCAREA_LON_LON_RANCH,          ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Malon", "Song from Malon", true),
    RC_OBJECT(RC_LLR_STABLES_LEFT_COW,                                        RCVORMQ_BOTH,    RCTYPE_COW,           RCAREA_LON_LON_RANCH,          ACTOR_EN_COW,       SCENE_STABLE,                         TWO_ACTOR_PARAMS(-122,-254), GI_MILK,             "Stables Left Cow", "LLR Stables Left Cow", false),
    RC_OBJECT(RC_LLR_STABLES_RIGHT_COW,                                       RCVORMQ_BOTH,    RCTYPE_COW,           RCAREA_LON_LON_RANCH,          ACTOR_EN_COW,       SCENE_STABLE,                         TWO_ACTOR_PARAMS(116,-254),  GI_MILK,             "Stables Right Cow", "LLR Stables Right Cow", false),
    RC_OBJECT(RC_LLR_TOWER_LEFT_COW,                                          RCVORMQ_BOTH,    RCTYPE_COW,           RCAREA_LON_LON_RANCH,          ACTOR_EN_COW,       SCENE_LON_LON_BUILDINGS,              TWO_ACTOR_PARAMS(-229,157),  GI_MILK,             "Tower Left Cow", "LLR Tower Left Cow", false),
    RC_OBJECT(RC_LLR_TOWER_RIGHT_COW,                                         RCVORMQ_BOTH,    RCTYPE_COW,           RCAREA_LON_LON_RANCH,          ACTOR_EN_COW,       SCENE_LON_LON_BUILDINGS,              TWO_ACTOR_PARAMS(-142,-140), GI_MILK,             "Tower Right Cow", "LLR Tower Right Cow", false),

    RC_OBJECT(RC_DEKU_TREE_MAP_CHEST,                                         RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      2083,                        GI_MAP,              "Map Chest", "Deku Tree Map Chest", true),
    RC_OBJECT(RC_DEKU_TREE_COMPASS_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      2050,                        GI_COMPASS,          "Compass Chest", "Deku Tree Compass Chest", true),
    RC_OBJECT(RC_DEKU_TREE_COMPASS_ROOM_SIDE_CHEST,                           RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      22790,                       GI_HEART,            "Compass Room Side Chest", "Deku Tree Compass Room Side Chest", false),
    RC_OBJECT(RC_DEKU_TREE_BASEMENT_CHEST,                                    RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      22788,                       GI_HEART,            "Basement Chest", "Deku Tree Basement Chest", false),
    RC_OBJECT(RC_DEKU_TREE_SLINGSHOT_CHEST,                                   RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      161,                         GI_SLINGSHOT,        "Slingshot Chest", "Deku Tree Slingshot Chest", true),
    RC_OBJECT(RC_DEKU_TREE_SLINGSHOT_ROOM_SIDE_CHEST,                         RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      22789,                       GI_HEART,            "Slingshot Room Side Chest", "Deku Tree Slingshot Room Side Chest", false),
    RC_OBJECT(RC_DEKU_TREE_MQ_MAP_CHEST,                                      RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      2083,                        GI_MAP,              "MQ Map Chest", "Deku Tree MQ Map Chest", true),
    RC_OBJECT(RC_DEKU_TREE_MQ_COMPASS_CHEST,                                  RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      2049,                        GI_COMPASS,          "MQ Compass Chest", "Deku Tree MQ Compass Chest", true),
    RC_OBJECT(RC_DEKU_TREE_MQ_SLINGSHOT_CHEST,                                RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      4262,                        GI_SLINGSHOT,        "MQ Slingshot Chest", "Deku Tree MQ Slingshot Chest", true),
    RC_OBJECT(RC_DEKU_TREE_MQ_SLINGSHOT_ROOM_BACK_CHEST,                      RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      -31454,                      GI_SHIELD_DEKU,      "MQ Slingshot Room Back Chest", "Deku Tree MQ Slingshot Room Back Chest", false),
    RC_OBJECT(RC_DEKU_TREE_MQ_BASEMENT_CHEST,                                 RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      -31452,                      GI_SHIELD_DEKU,      "MQ Basement Chest", "Deku Tree MQ Basement Chest", false),
    RC_OBJECT(RC_DEKU_TREE_MQ_BEFORE_SPINNING_LOG_CHEST,                      RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      22789,                       GI_HEART,            "MQ Before Spinning Log Chest", "Deku Tree MQ Before Spinning Log Chest", false),
    RC_OBJECT(RC_DEKU_TREE_MQ_AFTER_SPINNING_LOG_CHEST,                       RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_DEKU_TREE,                      23200,                       GI_RUPEE_PURPLE,     "MQ After Spinning Log Chest", "Deku Tree MQ After Spinning Log Chest", false),
    RC_OBJECT(RC_DEKU_TREE_MQ_DEKU_SCRUB,                                     RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_DEKU_TREE,              ACTOR_EN_DNS,       SCENE_DEKU_TREE,                      0x04,                        GI_SHIELD_DEKU,      "MQ Deku Scrub", "Deku Tree MQ Deku Scrub", false),
    RC_OBJECT(RC_DEKU_TREE_GS_BASEMENT_BACK_ROOM,                             RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_DEKU_TREE,                      8193,                        GI_SKULL_TOKEN,      "GS Basement Back Room", "Deku Tree GS Basement Back Room", true),
    RC_OBJECT(RC_DEKU_TREE_GS_BASEMENT_GATE,                                  RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_DEKU_TREE,                      8194,                        GI_SKULL_TOKEN,      "GS Basement Gate", "Deku Tree GS Basement Gate", true),
    RC_OBJECT(RC_DEKU_TREE_GS_BASEMENT_VINES,                                 RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_DEKU_TREE,                      8196,                        GI_SKULL_TOKEN,      "GS Basement Vines", "Deku Tree GS Basement Vines", true),
    RC_OBJECT(RC_DEKU_TREE_GS_COMPASS_ROOM,                                   RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_DEKU_TREE,                      8200,                        GI_SKULL_TOKEN,      "GS Compass Room", "Deku Tree GS Compass Room", true),
    RC_OBJECT(RC_DEKU_TREE_MQ_GS_LOBBY,                                       RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_DEKU_TREE,                      8194,                        GI_SKULL_TOKEN,      "MQ GS Lobby", "Deku Tree MQ GS Lobby", true),
    RC_OBJECT(RC_DEKU_TREE_MQ_GS_COMPASS_ROOM,                                RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_DEKU_TREE,                      8200,                        GI_SKULL_TOKEN,      "MQ GS Compass Room", "Deku Tree MQ GS Compass Room", true),
    RC_OBJECT(RC_DEKU_TREE_MQ_GS_BASEMENT_GRAVES_ROOM,                        RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_DEKU_TREE,                      8196,                        GI_SKULL_TOKEN,      "MQ GS Basement Graves Room", "Deku Tree MQ GS Basement Graves Room", true),
    RC_OBJECT(RC_DEKU_TREE_MQ_GS_BASEMENT_BACK_ROOM,                          RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_DEKU_TREE,                      8193,                        GI_SKULL_TOKEN,      "MQ GS Basement Back Room", "Deku Tree MQ GS Basement Back Room", true),
    RC_OBJECT(RC_QUEEN_GOHMA,                                                 RCVORMQ_BOTH,    RCTYPE_DUNGEON_REWARD,             RCAREA_DEKU_TREE,              ACTOR_DOOR_WARP1,   SCENE_DEKU_TREE_BOSS,                 0x00,                        GI_NONE,             "Queen Gohma", "Queen Gohma", true),
    RC_OBJECT(RC_DEKU_TREE_QUEEN_GOHMA_HEART,                                 RCVORMQ_BOTH,    RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_DEKU_TREE,              ACTOR_ITEM_B_HEART, SCENE_DEKU_TREE_BOSS,                 0x00,                        GI_HEART_CONTAINER,  "Queen Gohma Heart Container", "Deku Tree Queen Gohma Heart Container", true),

    RC_OBJECT(RC_DODONGOS_CAVERN_BOSS_ROOM_CHEST,                             RCVORMQ_BOTH,    RCTYPE_STANDARD,                   RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN_BOSS,           20512,                       GI_BOMBS_5,          "Boss Room Chest", "Dodongos Cavern Boss Room Chest", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_MAP_CHEST,                                   RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                2088,                        GI_MAP,              "Map Chest", "Dodongos Cavern Map Chest", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_COMPASS_CHEST,                               RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                2053,                        GI_COMPASS,          "Compass Chest", "Dodongos Cavern Compass Chest", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_BOMB_FLOWER_PLATFORM_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                22982,                       GI_RUPEE_RED,        "Bomb Flower Platform Chest", "Dodongos Cavern Bomb Flower Platform Chest", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_BOMB_BAG_CHEST,                              RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                1604,                        GI_BOMB_BAG_20,      "Bomb Bag Chest", "Dodongos Cavern Bomb Bag Chest", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_END_OF_BRIDGE_CHEST,                         RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                21802,                       GI_SHIELD_DEKU,      "End Of Bridge Chest", "Dodongos Cavern End Of Bridge Chest", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_DEKU_SCRUB_NEAR_BOMB_BAG_LEFT,               RCVORMQ_VANILLA, RCTYPE_SCRUB,                      RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DODONGOS_CAVERN,                0x00,                        GI_NUTS_5_2,         "Deku Scrub Near Bomb Bag Left", "Dodongos Cavern Deku Scrub Near Bomb Bag Left", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_DEKU_SCRUB_SIDE_ROOM_NEAR_DODONGOS,          RCVORMQ_VANILLA, RCTYPE_SCRUB,                      RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DODONGOS_CAVERN,                0x01,                        GI_STICKS_1,         "Deku Scrub Side Room Near Dodongos", "Dodongos Cavern Deku Scrub Side Room Near Dodongos", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_DEKU_SCRUB_NEAR_BOMB_BAG_RIGHT,              RCVORMQ_VANILLA, RCTYPE_SCRUB,                      RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DODONGOS_CAVERN,                0x03,                        GI_SEEDS_30,         "Deku Scrub Near Bomb Bag Right", "Dodongos Cavern Deku Scrub Near Bomb Bag Right", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_DEKU_SCRUB_LOBBY,                            RCVORMQ_VANILLA, RCTYPE_SCRUB,                      RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DODONGOS_CAVERN,                0x04,                        GI_SHIELD_DEKU,      "Deku Scrub Lobby", "Dodongos Cavern Deku Scrub Lobby", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_MAP_CHEST,                                RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                2080,                        GI_MAP,              "MQ Map Chest", "Dodongos Cavern MQ Map Chest", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_BOMB_BAG_CHEST,                           RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                1604,                        GI_BOMB_BAG_20,      "MQ Bomb Bag Chest", "Dodongos Cavern MQ Bomb Bag Chest", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_COMPASS_CHEST,                            RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                6149,                        GI_COMPASS,          "MQ Compass Chest", "Dodongos Cavern MQ Compass Chest", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_LARVAE_ROOM_CHEST,                        RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                29986,                       GI_SHIELD_DEKU,      "MQ Larvae Room Chest", "Dodongos Cavern MQ Larvae Room Chest", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_TORCH_PUZZLE_ROOM_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                22947,                       GI_RUPEE_BLUE,       "MQ Torch Puzzle Room Chest", "Dodongos Cavern MQ Torch Puzzle Room Chest", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_UNDER_GRAVE_CHEST,                        RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DODONGOS_CAVERN,                21825,                       GI_SHIELD_HYLIAN,    "MQ Under Grave Chest", "Dodongos Cavern MQ Under Grave Chest", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_DEKU_SCRUB_LOBBY_REAR,                    RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DODONGOS_CAVERN,                0x01,                        GI_STICKS_1,         "MQ Deku Scrub Lobby Rear", "Dodongos Cavern Deku Scrub Lobby Rear", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_DEKU_SCRUB_LOBBY_FRONT,                   RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DODONGOS_CAVERN,                0x03,                        GI_SEEDS_30,         "MQ Deku Scrub Lobby Front", "Dodongos Cavern Deku Scrub Lobby Front", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_DEKU_SCRUB_STAIRCASE,                     RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DODONGOS_CAVERN,                0x04,                        GI_SHIELD_DEKU,      "MQ Deku Scrub Staircase", "Dodongos Cavern Deku Scrub Staircase", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_DEKU_SCRUB_SIDE_ROOM_NEAR_LOWER_LIZALFOS, RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DODONGOS_CAVERN,                0x07,                        GI_POTION_RED,       "MQ Deku Scrub Side Room Near Lower Lizalfos", "Dodongos Cavern Deku Scrub Side Room Near Lower Lizalfos", false),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_VINES_ABOVE_STAIRS,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8449,                        GI_SKULL_TOKEN,      "GS Vines Above Stairs", "Dodongos Cavern GS Vines Above Stairs", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_SCARECROW,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8450,                        GI_SKULL_TOKEN,      "GS Scarecrow", "Dodongos Cavern GS Scarecrow", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_ALCOVE_ABOVE_STAIRS,                      RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8452,                        GI_SKULL_TOKEN,      "GS Alcove Above Stairs", "Dodongos Cavern GS Alcove Above Stairs", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_BACK_ROOM,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8456,                        GI_SKULL_TOKEN,      "GS Back Room", "Dodongos Cavern GS Back Room", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_SIDE_ROOM_NEAR_LOWER_LIZALFOS,            RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8464,                        GI_SKULL_TOKEN,      "GS Side Room Near Lower Lizalfos", "Dodongos Cavern GS Side Room Near Lower Lizalfos", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_SCRUB_ROOM,                            RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8450,                        GI_SKULL_TOKEN,      "MQ GS Scrub Room", "Dodongos Cavern MQ GS Scrub Room", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_SONG_OF_TIME_BLOCK_ROOM,               RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8456,                        GI_SKULL_TOKEN,      "MQ GS Song of Time Block Room", "Dodongos Cavern MQ GS Song of Time Block Room", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_LIZALFOS_ROOM,                         RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8452,                        GI_SKULL_TOKEN,      "MQ GS Lizalfos Room", "Dodongos Cavern MQ GS Lizalfos Room", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_LARVAE_ROOM,                           RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8464,                        GI_SKULL_TOKEN,      "MQ GS Larvae Room", "Dodongos Cavern MQ GS Larvae Room", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_BACK_AREA,                             RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DODONGOS_CAVERN,                8449,                        GI_SKULL_TOKEN,      "MQ GS Back Room", "Dodongos Cavern MQ GS Back Room", true),
    RC_OBJECT(RC_KING_DODONGO,                                                RCVORMQ_BOTH,    RCTYPE_DUNGEON_REWARD,             RCAREA_DODONGOS_CAVERN,        ACTOR_DOOR_WARP1,   SCENE_DODONGOS_CAVERN_BOSS,           0x00,                        GI_NONE,             "King Dodongo", "King Dodongo", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_KING_DODONGO_HEART,                          RCVORMQ_BOTH,    RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_DODONGOS_CAVERN,        ACTOR_ITEM_B_HEART, SCENE_DODONGOS_CAVERN_BOSS,           0x00,                        GI_HEART_CONTAINER,  "King Dodongo Heart Container", "Dodongos Cavern King Dodongo Heart Container", true),
    RC_OBJECT(RC_DODONGOS_CAVERN_GOSSIP_STONE,                                RCVORMQ_VANILLA, RCTYPE_GOSSIP_STONE,               RCAREA_DODONGOS_CAVERN,        ACTOR_EN_GS,        SCENE_DODONGOS_CAVERN,                4372,                        GI_NONE,             "Gossip Stone", "Dodongo's Cavern Gossip Stone", false),

    RC_OBJECT(RC_JABU_JABUS_BELLY_MAP_CHEST,                                  RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      6178,                        GI_MAP,              "Map Chest", "Jabu Jabus Belly Map Chest", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_COMPASS_CHEST,                              RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      -18428,                      GI_COMPASS,          "Compass Chest", "Jabu Jabus Belly Compass Chest", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_BOOMERANG_CHEST,                            RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      4289,                        GI_BOOMERANG,        "Boomerang Chest", "Jabu Jabus Belly Boomerang Chest", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_DEKU_SCRUB,                                 RCVORMQ_VANILLA, RCTYPE_SCRUB,                      RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_DNS,       SCENE_JABU_JABU,                      0x00,                        GI_NUTS_5_2,         "Deku Scrub", "Jabu Jabus Belly Deku Scrub", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_FIRST_ROOM_SIDE_CHEST,                   RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      -32699,                      GI_NUTS_5,           "MQ First Room Side Chest", "Jabu Jabus Belly MQ First Room Side Chest", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_MAP_CHEST,                               RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      -18397,                      GI_MAP,              "MQ Map Chest", "Jabu Jabus Belly MQ Map Chest", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_SECOND_ROOM_LOWER_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      20546,                       GI_NUTS_5,           "MQ Second Room Lower Chest", "Jabu Jabus Belly MQ Second Room Lower Chest", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_COMPASS_CHEST,                           RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      -18432,                      GI_COMPASS,          "MQ Compass Chest", "Jabu Jabus Belly MQ Compass Chest", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_SECOND_ROOM_UPPER_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      -30457,                      GI_HEART,            "MQ Second Room Upper Chest", "Jabu Jabus Belly MQ Second Room Upper Chest", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_BASEMENT_NEAR_SWITCHES_CHEST,            RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      -32696,                      GI_NUTS_5,           "MQ Basement Near Switches Chest", "Jabu Jabus Belly MQ Basement Near Switches Chest", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_BASEMENT_NEAR_VINES_CHEST,               RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      -32668,                      GI_BOMBCHUS_10,      "MQ Basement Near Vines Chest", "Jabu Jabus Belly MQ Basement Near Vines Chest", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_NEAR_BOSS_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      -31446,                      GI_SHIELD_DEKU,      "MQ Near Boss Chest", "Jabu Jabus Belly MQ Near Boss Chest", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_FALLING_LIKE_LIKE_ROOM_CHEST,            RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      28905,                       GI_STICKS_1,         "MQ Falling Like Like Room Chest", "Jabu Jabus Belly MQ Falling Like Like Room Chest", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_BOOMERANG_ROOM_SMALL_CHEST,              RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      20545,                       GI_NUTS_5,           "MQ Boomerang Room Small Chest", "Jabu Jabus Belly MQ Boomerang Room Small Chest", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_BOOMERANG_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_JABU_JABU,                      4294,                        GI_BOOMERANG,        "MQ Boomerang Chest", "Jabu Jabus Belly MQ Boomerang Chest", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_COW,                                     RCVORMQ_MQ,      RCTYPE_COW,                        RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_COW,       SCENE_JABU_JABU,                      0x00,                        GI_MILK,             "MQ Cow", "Jabu Jabus Belly MQ Cow", false),
    RC_OBJECT(RC_JABU_JABUS_BELLY_GS_LOBBY_BASEMENT_LOWER,                    RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_JABU_JABU,                      8705,                        GI_SKULL_TOKEN,      "GS Lobby Basement Lower", "Jabu Jabus Belly GS Lobby Basement Lower", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_GS_LOBBY_BASEMENT_UPPER,                    RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_JABU_JABU,                      8706,                        GI_SKULL_TOKEN,      "GS Lobby Basement Upper", "Jabu Jabus Belly GS Lobby Basement Upper", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_GS_NEAR_BOSS,                               RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_JABU_JABU,                      8708,                        GI_SKULL_TOKEN,      "GS Near Boss", "Jabu Jabus Belly GS Near Boss", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_GS_WATER_SWITCH_ROOM,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_JABU_JABU,                      8712,                        GI_SKULL_TOKEN,      "GS Water Switch Room", "Jabu Jabus Belly GS Water Switch Room", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_GS_TAILPASARAN_ROOM,                     RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_JABU_JABU,                      8708,                        GI_SKULL_TOKEN,      "MQ GS Tail Parasan Room", "Jabu Jabus Belly MQ GS Tail Parasan Room", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_GS_INVISIBLE_ENEMIES_ROOM,               RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_JABU_JABU,                      8712,                        GI_SKULL_TOKEN,      "MQ GS Invisible Enemies Room", "Jabu Jabus Belly MQ GS Invisible Enemies Room", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_GS_BOOMERANG_CHEST_ROOM,                 RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_JABU_JABU,                      8705,                        GI_SKULL_TOKEN,      "MQ GS Boomerang Chest Room", "Jabu Jabus Belly MQ GS Boomerang Chest Room", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_GS_NEAR_BOSS,                            RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_JABU_JABU,                      8706,                        GI_SKULL_TOKEN,      "MQ GS Near Boss", "Jabu Jabus Belly MQ GS Near Boss", true),
    RC_OBJECT(RC_BARINADE,                                                    RCVORMQ_BOTH,    RCTYPE_DUNGEON_REWARD,             RCAREA_JABU_JABUS_BELLY,       ACTOR_DOOR_WARP1,   SCENE_JABU_JABU_BOSS,                 0x00,                        GI_NONE,             "Barinade", "Barinade", true),
    RC_OBJECT(RC_JABU_JABUS_BELLY_BARINADE_HEART,                             RCVORMQ_BOTH,    RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_JABU_JABUS_BELLY,       ACTOR_ITEM_B_HEART, SCENE_JABU_JABU_BOSS,                 0x00,                        GI_HEART_CONTAINER,  "Barinade Heart Container", "Jabu Jabus Belly Barinade Heart Container", true),

    RC_OBJECT(RC_FOREST_TEMPLE_FIRST_ROOM_CHEST,                              RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  22595,                       GI_KEY_SMALL,        "First Room Chest", "Forest Temple First Room Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_FIRST_STALFOS_CHEST,                           RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  30784,                       GI_KEY_SMALL,        "First Stalfos Chest", "Forest Temple First Stalfos Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_RAISED_ISLAND_COURTYARD_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  22789,                       GI_HEART,            "Raised Island Courtyard Chest", "Forest Temple Raised Island Courtyard Chest", false),
    RC_OBJECT(RC_FOREST_TEMPLE_MAP_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  6177,                        GI_MAP,              "Map Chest", "Forest Temple Map Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_WELL_CHEST,                                    RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  22601,                       GI_KEY_SMALL,        "Well Chest", "Forest Temple Well Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_FALLING_CEILING_ROOM_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  22855,                       GI_ARROWS_MEDIUM,    "Falling Ceiling Room Chest", "Forest Temple Falling Ceiling Room Chest", false),
    RC_OBJECT(RC_FOREST_TEMPLE_EYE_SWITCH_CHEST,                              RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  -30364,                      GI_ARROWS_LARGE,     "Eye Switch Chest", "Forest Temple Eye Switch Chest", false),
    RC_OBJECT(RC_FOREST_TEMPLE_BOSS_KEY_CHEST,                                RCVORMQ_VANILLA, RCTYPE_BOSS_KEY,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  10222,                       GI_KEY_BOSS,         "Boss Key Chest", "Forest Temple Boss Key Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_FLOORMASTER_CHEST,                             RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  30786,                       GI_KEY_SMALL,        "Floormaster Chest", "Forest Temple Floormaster Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_BOW_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  -20340,                      GI_BOW,              "Bow Chest", "Forest Temple Bow Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_RED_POE_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  30797,                       GI_KEY_SMALL,        "Red Poe Chest", "Forest Temple Red Poe Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_BLUE_POE_CHEST,                                RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  6159,                        GI_COMPASS,          "Blue Poe Chest", "Forest Temple Blue Poe Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_BASEMENT_CHEST,                                RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  22827,                       GI_ARROWS_SMALL,     "Basement Chest", "Forest Temple Basement Chest", false),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_FIRST_ROOM_CHEST,                           RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  -30653,                      GI_KEY_SMALL,        "MQ First Room Chest", "Forest Temple MQ First Room Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_WOLFOS_CHEST,                               RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  30784,                       GI_KEY_SMALL,        "MQ Wolfos Chest", "Forest Temple MQ Wolfos Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_BOW_CHEST,                                  RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  -20340,                      GI_BOW,              "MQ Bow Chest", "Forest Temple MQ Bow Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_RAISED_ISLAND_COURTYARD_LOWER_CHEST,        RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  22593,                       GI_KEY_SMALL,        "MQ Raised Island Courtyard Lower Chest", "Forest Temple MQ Raised Island Courtyard Lower Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_RAISED_ISLAND_COURTYARD_UPPER_CHEST,        RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  22597,                       GI_KEY_SMALL,        "MQ Raised Island Courtyard Upper Chest", "Forest Temple MQ Raised Island Courtyard Upper Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_WELL_CHEST,                                 RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  22601,                       GI_KEY_SMALL,        "MQ Well Chest", "Forest Temple MQ Well Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_MAP_CHEST,                                  RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  6189,                        GI_MAP,              "MQ Map Chest", "Forest Temple MQ Map Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_COMPASS_CHEST,                              RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  6159,                        GI_COMPASS,          "MQ Compass Chest", "Forest Temple MQ Compass Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_FALLING_CEILING_ROOM_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  -30426,                      GI_ARROWS_SMALL,     "MQ Falling Ceiling Room Chest", "Forest Temple MQ Falling Ceiling Room Chest", false),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_BASEMENT_CHEST,                             RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  22827,                       GI_ARROWS_SMALL,     "MQ Basement Chest", "Forest Temple MQ Basement Chest", false),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_REDEAD_CHEST,                               RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  30786,                       GI_KEY_SMALL,        "MQ Redead Chest", "Forest Temple MQ Redead Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_BOSS_KEY_CHEST,                             RCVORMQ_MQ,      RCTYPE_BOSS_KEY,                   RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_FOREST_TEMPLE,                  10222,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Forest Temple MQ Boss Key Chest", true),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_RAISED_ISLAND_COURTYARD,                    RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8961,                        GI_SKULL_TOKEN,      "GS Raised Island Courtyard", "Forest Temple GS Raised Island Courtyard", true),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_FIRST_ROOM,                                 RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8962,                        GI_SKULL_TOKEN,      "GS First Room", "Forest Temple GS First Room", true),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_LEVEL_ISLAND_COURTYARD,                     RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8964,                        GI_SKULL_TOKEN,      "GS Level Island Courtyard", "Forest Temple GS Level Island Courtyard", true),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_LOBBY,                                      RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8968,                        GI_SKULL_TOKEN,      "GS Lobby", "Forest Temple GS Lobby", true),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_BASEMENT,                                   RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8976,                        GI_SKULL_TOKEN,      "GS Basement", "Forest Temple GS Basement", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_FIRST_HALLWAY,                           RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8962,                        GI_SKULL_TOKEN,      "MQ GS First Hallway", "Forest Temple MQ GS First Hallway", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_BLOCK_PUSH_ROOM,                         RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8976,                        GI_SKULL_TOKEN,      "MQ GS Block Push Room", "Forest Temple MQ GS Block Push Room", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_RAISED_ISLAND_COURTYARD,                 RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8961,                        GI_SKULL_TOKEN,      "MQ GS Raised Island Courtyard", "Forest Temple MQ GS Raised Island Courtyard", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_LEVEL_ISLAND_COURTYARD,                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8964,                        GI_SKULL_TOKEN,      "MQ GS Level Island Courtyard", "Forest Temple MQ GS Level Island Courtyard", true),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_WELL,                                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_FOREST_TEMPLE,                  8968,                        GI_SKULL_TOKEN,      "MQ GS Well", "Forest Temple MQ GS Well", true),
    RC_OBJECT(RC_PHANTOM_GANON,                                               RCVORMQ_BOTH,    RCTYPE_DUNGEON_REWARD,             RCAREA_FOREST_TEMPLE,          ACTOR_DOOR_WARP1,   SCENE_FOREST_TEMPLE_BOSS,             0x00,                        GI_NONE,             "Phantom Ganon", "Phantom Ganon", true),
    RC_OBJECT(RC_FOREST_TEMPLE_PHANTOM_GANON_HEART,                           RCVORMQ_BOTH,    RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_FOREST_TEMPLE,          ACTOR_ITEM_B_HEART, SCENE_FOREST_TEMPLE_BOSS,             0x00,                        GI_HEART_CONTAINER,  "Phantom Ganon Heart Container", "Forest Temple Phantom Ganon Heart Container", true),

    RC_OBJECT(RC_FIRE_TEMPLE_NEAR_BOSS_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22593,                       GI_KEY_SMALL,        "Near Boss Chest", "Fire Temple Near Boss Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_FLARE_DANCER_CHEST,                              RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    31936,                       GI_BOMBS_10,         "Flare Dancer Chest", "Fire Temple Flare Dancer Chest", false),
    RC_OBJECT(RC_FIRE_TEMPLE_BOSS_KEY_CHEST,                                  RCVORMQ_VANILLA, RCTYPE_BOSS_KEY,                   RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    10220,                       GI_KEY_BOSS,         "Boss Key Chest", "Fire Temple Boss Key Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_BIG_LAVA_ROOM_BLOCKED_DOOR_CHEST,                RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22594,                       GI_KEY_SMALL,        "Big Lava Room Blocked Door Chest", "Fire Temple Big Lava Room Blocked Door Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_BIG_LAVA_ROOM_LOWER_OPEN_DOOR_CHEST,             RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22596,                       GI_KEY_SMALL,        "Big Lava Room Lower Open Door Chest", "Fire Temple Big Lava Room Lower Open Door Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_BOULDER_MAZE_LOWER_CHEST,                        RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22595,                       GI_KEY_SMALL,        "Boulder Maze Lower Chest", "Fire Temple Boulder Maze Lower Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_BOULDER_MAZE_UPPER_CHEST,                        RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22598,                       GI_KEY_SMALL,        "Boulder Maze Upper Chest", "Fire Temple Boulder Maze Upper Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_BOULDER_MAZE_SIDE_ROOM_CHEST,                    RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22600,                       GI_KEY_SMALL,        "Boulder Maze Side Room Chest", "Fire Temple Boulder Maze Side Room Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_BOULDER_MAZE_SHORTCUT_CHEST,                     RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22603,                       GI_KEY_SMALL,        "Boulder Maze Shortcut Chest", "Fire Temple Boulder Maze Shortcut Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_SCARECROW_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    23245,                       GI_RUPEE_GOLD,       "Scarecrow Chest", "Fire Temple Scarecrow Chest", false),
    RC_OBJECT(RC_FIRE_TEMPLE_MAP_CHEST,                                       RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    2090,                        GI_MAP,              "Map Chest", "Fire Temple Map Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_COMPASS_CHEST,                                   RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    2055,                        GI_COMPASS,          "Compass Chest", "Fire Temple Compass Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_HIGHEST_GORON_CHEST,                             RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22601,                       GI_KEY_SMALL,        "Highest Goron Chest", "Fire Temple Highest Goron Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MEGATON_HAMMER_CHEST,                            RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    421,                         GI_HAMMER,           "Megaton Hammer Chest", "Fire Temple Megaton Hammer Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_NEAR_BOSS_CHEST,                              RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22599,                       GI_KEY_SMALL,        "MQ Near Boss Chest", "Fire Temple MQ Near Boss Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_MEGATON_HAMMER_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    4512,                        GI_HAMMER,           "MQ Megaton Hammer Chest", "Fire Temple MQ Megaton Hammer Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_COMPASS_CHEST,                                RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    2059,                        GI_COMPASS,          "MQ Compass Chest", "Fire Temple MQ Compass Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_LIZALFOS_MAZE_LOWER_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    23747,                       GI_BOMBS_10,         "MQ Lizalfos Maze Lower Chest", "Fire Temple MQ Lizalfos Maze Lower Chest", false),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_LIZALFOS_MAZE_UPPER_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    23782,                       GI_BOMBS_20,         "MQ Lizalfos Maze Upper Chest", "Fire Temple MQ Lizalfos Maze Upper Chest", false),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_CHEST_ON_FIRE,                                RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22597,                       GI_KEY_SMALL,        "MQ Chest on Fire", "Fire Temple MQ Chest on Fire", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_MAP_ROOM_SIDE_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    30018,                       GI_SHIELD_HYLIAN,    "MQ Map Room Side Chest", "Fire Temple MQ Map Room Side Chest", false),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_MAP_CHEST,                                    RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    2092,                        GI_MAP,              "MQ Map Chest", "Fire Temple MQ Map Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_BOSS_KEY_CHEST,                               RCVORMQ_MQ,      RCTYPE_BOSS_KEY,                   RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    10212,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Fire Temple MQ Boss Key Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_BIG_LAVA_ROOM_BLOCKED_DOOR_CHEST,             RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22593,                       GI_KEY_SMALL,        "MQ Big Lava Room Blocked Door Chest", "Fire Temple MQ Big Lava Room Blocked Door Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_LIZALFOS_MAZE_SIDE_ROOM_CHEST,                RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_FIRE_TEMPLE,                    22600,                       GI_KEY_SMALL,        "MQ Lizalfos Maze Side Room Chest", "Fire Temple MQ Lizalfos Maze Side Room Chest", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_FREESTANDING_KEY,                             RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_FIRE_TEMPLE,            ACTOR_EN_ITEM00,    SCENE_FIRE_TEMPLE,                    7185,                        GI_KEY_SMALL,        "MQ Freestanding Key", "Fire Temple MQ Freestanding Key", true),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_SONG_OF_TIME_ROOM,                            RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9217,                        GI_SKULL_TOKEN,      "GS Song of Time Room", "Fire Temple GS Song of Time Room", true),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_BOSS_KEY_LOOP,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9218,                        GI_SKULL_TOKEN,      "GS Boss Key Loop", "Fire Temple GS Boss Key Loop", true),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_BOULDER_MAZE,                                 RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9220,                        GI_SKULL_TOKEN,      "GS Boulder Maze", "Fire Temple GS Boulder Maze", true),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_SCARECROW_TOP,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9224,                        GI_SKULL_TOKEN,      "GS Scarecrow Top", "Fire Temple GS Scarecrow Top", true),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_SCARECROW_CLIMB,                              RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9232,                        GI_SKULL_TOKEN,      "GS Scarecrow Climb", "Fire Temple GS Scarecrow Climb", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_ABOVE_FIRE_WALL_MAZE,                      RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9218,                        GI_SKULL_TOKEN,      "MQ GS Above Fire Wall Maze", "Fire Temple MQ GS Above Fire Wall Maze", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_FIRE_WALL_MAZE_CENTER,                     RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9224,                        GI_SKULL_TOKEN,      "MQ GS Fire Wall Maze Center", "Fire Temple MQ GS Fire Wall Maze Center", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_BIG_LAVA_ROOM_OPEN_DOOR,                   RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9217,                        GI_SKULL_TOKEN,      "MQ GS Big Lava Room Open Door", "Fire Temple MQ GS Big Lava Room Open Door", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_FIRE_WALL_MAZE_SIDE_ROOM,                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9232,                        GI_SKULL_TOKEN,      "MQ GS Fire Wall Maze Side Room", "Fire Temple MQ GS Fire Wall Maze Side Room", true),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_SKULL_ON_FIRE,                             RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_FIRE_TEMPLE,                    9220,                        GI_SKULL_TOKEN,      "MQ GS Skull on Fire", "Fire Temple MQ GS Skull on Fire", true),
    RC_OBJECT(RC_VOLVAGIA,                                                    RCVORMQ_BOTH,    RCTYPE_DUNGEON_REWARD,             RCAREA_FIRE_TEMPLE,            ACTOR_DOOR_WARP1,   SCENE_FIRE_TEMPLE_BOSS,               0x00,                        GI_NONE,             "Volvagia", "Volvagia", true),
    RC_OBJECT(RC_FIRE_TEMPLE_VOLVAGIA_HEART,                                  RCVORMQ_BOTH,    RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_FIRE_TEMPLE,            ACTOR_ITEM_B_HEART, SCENE_FIRE_TEMPLE_BOSS,               0x00,                        GI_HEART_CONTAINER,  "Volvagia Heart Container", "Fire Temple Volvagia Heart Container", true),

    RC_OBJECT(RC_WATER_TEMPLE_MAP_CHEST,                                      RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   6178,                        GI_MAP,              "Map Chest", "Water Temple Map Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_COMPASS_CHEST,                                  RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   2057,                        GI_COMPASS,          "Compass Chest", "Water Temple Compass Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_TORCHES_CHEST,                                  RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   30785,                       GI_KEY_SMALL,        "Torches Chest", "Water Temple Torches Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_DRAGON_CHEST,                                   RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   22602,                       GI_KEY_SMALL,        "Dragon Chest", "Water Temple Dragon Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_CENTRAL_BOW_TARGET_CHEST,                       RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   22600,                       GI_KEY_SMALL,        "Central Bow Target Chest", "Water Temple Central Bow Target Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_CENTRAL_PILLAR_CHEST,                           RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   22598,                       GI_KEY_SMALL,        "Central Pillar Chest", "Water Temple Central Pillar Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_CRACKED_WALL_CHEST,                             RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   22592,                       GI_KEY_SMALL,        "Cracked Wall Chest", "Water Temple Cracked Wall Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_BOSS_KEY_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_BOSS_KEY,                   RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   10213,                       GI_KEY_BOSS,         "Boss Key Chest", "Water Temple Boss Key Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_LONGSHOT_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   295,                         GI_LONGSHOT,         "Longshot Chest", "Water Temple Longshot Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_RIVER_CHEST,                                    RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   22595,                       GI_KEY_SMALL,        "River Chest", "Water Temple River Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_CENTRAL_PILLAR_CHEST,                        RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   -30650,                      GI_KEY_SMALL,        "MQ Central Pillar Chest", "Water Temple MQ Central Pillar Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_BOSS_KEY_CHEST,                              RCVORMQ_MQ,      RCTYPE_BOSS_KEY,                   RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   10213,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Water Temple MQ Boss Key Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_LONGSHOT_CHEST,                              RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   -20192,                      GI_LONGSHOT,         "MQ Longshot Chest", "Water Temple MQ Longshot Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_COMPASS_CHEST,                               RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   6145,                        GI_COMPASS,          "MQ Compass Chest", "Water Temple MQ Compass Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_MAP_CHEST,                                   RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_WATER_TEMPLE,                   -18398,                      GI_MAP,              "MQ Map Chest", "Water Temple MQ Map Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_FREESTANDING_KEY,                            RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_WATER_TEMPLE,           ACTOR_EN_ITEM00,    SCENE_WATER_TEMPLE,                   273,                         GI_KEY_SMALL,        "MQ Freestanding Key", "Water Temple MQ Freestanding Key", true),
    RC_OBJECT(RC_WATER_TEMPLE_GS_BEHIND_GATE,                                 RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9473,                        GI_SKULL_TOKEN,      "GS Behind Gate", "Water Temple GS Behind Gate", true),
    RC_OBJECT(RC_WATER_TEMPLE_GS_FALLING_PLATFORM_ROOM,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9474,                        GI_SKULL_TOKEN,      "GS Falling Platform Room", "Water Temple GS Falling Platform Room", true),
    RC_OBJECT(RC_WATER_TEMPLE_GS_CENTRAL_PILLAR,                              RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9476,                        GI_SKULL_TOKEN,      "GS Central Pillar", "Water Temple GS Central Pillar", true),
    RC_OBJECT(RC_WATER_TEMPLE_GS_NEAR_BOSS_KEY_CHEST,                         RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9480,                        GI_SKULL_TOKEN,      "GS Near Boss Key Chest", "Water Temple GS Near Boss Key Chest", true),
    RC_OBJECT(RC_WATER_TEMPLE_GS_RIVER,                                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9488,                        GI_SKULL_TOKEN,      "GS River", "Water Temple GS River", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_BEFORE_UPPER_WATER_SWITCH,                RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9476,                        GI_SKULL_TOKEN,      "MQ GS Before Upper Water Switch", "Water Temple MQ GS Before Upper Water Switch", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_FREESTANDING_KEY_AREA,                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9480,                        GI_SKULL_TOKEN,      "MQ GS Freestanding Key Area", "Water Temple MQ GS Freestanding Key Area", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_LIZALFOS_HALLWAY,                         RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9473,                        GI_SKULL_TOKEN,      "MQ GS Lizalfos Hallway", "Water Temple MQ GS Lizalfos Hallway", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_RIVER,                                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9474,                        GI_SKULL_TOKEN,      "MQ GS River", "Water Temple MQ GS River", true),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_TRIPLE_WALL_TORCH,                        RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_WATER_TEMPLE,                   9488,                        GI_SKULL_TOKEN,      "MQ GS Triple Wall Torch", "Water Temple MQ GS Triple Wall Torch", true),
    RC_OBJECT(RC_MORPHA,                                                      RCVORMQ_BOTH,    RCTYPE_DUNGEON_REWARD,             RCAREA_WATER_TEMPLE,           ACTOR_DOOR_WARP1,   SCENE_WATER_TEMPLE_BOSS,              0x00,                        GI_NONE,             "Morpha", "Morpha", true),
    RC_OBJECT(RC_WATER_TEMPLE_MORPHA_HEART,                                   RCVORMQ_BOTH,    RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_WATER_TEMPLE,           ACTOR_ITEM_B_HEART, SCENE_WATER_TEMPLE_BOSS,              0x00,                        GI_HEART_CONTAINER,  "Morpha Heart Container", "Water Temple Morpha Heart Container", true),

    RC_OBJECT(RC_SPIRIT_TEMPLE_SILVER_GAUNTLETS_CHEST,                        RCVORMQ_BOTH,    RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_DESERT_COLOSSUS,                1707,                        GI_GAUNTLETS_SILVER, "Silver Gauntlets Chest", "Spirit Temple Silver Gauntlets Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MIRROR_SHIELD_CHEST,                           RCVORMQ_BOTH,    RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_DESERT_COLOSSUS,                13673,                       GI_SHIELD_MIRROR,    "Mirror Shield Chest", "Spirit Temple Mirror Shield Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_CHILD_BRIDGE_CHEST,                            RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  21800,                       GI_SHIELD_DEKU,      "Child Bridge Chest", "Spirit Temple Child Bridge Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_CHILD_EARLY_TORCHES_CHEST,                     RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30656,                      GI_KEY_SMALL,        "Child Early Torches Chest", "Spirit Temple Child Early Torches Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_COMPASS_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  14340,                       GI_COMPASS,          "Compass Chest", "Spirit Temple Compass Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_EARLY_ADULT_RIGHT_CHEST,                       RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  22599,                       GI_KEY_SMALL,        "Early Adult Right Chest", "Spirit Temple Early Adult Right Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_FIRST_MIRROR_LEFT_CHEST,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30451,                      GI_HEART,            "First Mirror Left Chest", "Spirit Temple First Mirror Left Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_FIRST_MIRROR_RIGHT_CHEST,                      RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -28786,                      GI_ICE_TRAP,         "First Mirror Right Chest", "Spirit Temple First Mirror Right Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MAP_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -18397,                      GI_MAP,              "Map Chest", "Spirit Temple Map Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_CHILD_CLIMB_NORTH_CHEST,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -32666,                      GI_BOMBCHUS_10,      "Child Climb North Chest", "Spirit Temple Child Climb North Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_CHILD_CLIMB_EAST_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -31444,                      GI_SHIELD_DEKU,      "Child Climb East Chest", "Spirit Temple Child Climb East Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_SUN_BLOCK_ROOM_CHEST,                          RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30655,                      GI_KEY_SMALL,        "Sun Block Room Chest", "Spirit Temple Sun Block Room Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_STATUE_ROOM_HAND_CHEST,                        RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30654,                      GI_KEY_SMALL,        "Statue Room Hand Chest", "Spirit Temple Statue Room Hand Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_STATUE_ROOM_NORTHEAST_CHEST,                   RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30577,                      GI_MAGIC_LARGE,      "Statue Room Northeast Chest", "Spirit Temple Statue Room Northeast Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_NEAR_FOUR_ARMOS_CHEST,                         RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  22597,                       GI_KEY_SMALL,        "Near Four Armos Chest", "Spirit Temple Near Four Armos Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_HALLWAY_RIGHT_INVISIBLE_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  26900,                       GI_HEART,            "Hallway Right Invisible Chest", "Spirit Temple Hallway Right Invisible Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_HALLWAY_LEFT_INVISIBLE_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  26901,                       GI_HEART,            "Hallway Left Invisible Chest", "Spirit Temple Hallway Left Invisible Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_BOSS_KEY_CHEST,                                RCVORMQ_VANILLA, RCTYPE_BOSS_KEY,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  10218,                       GI_KEY_BOSS,         "Boss Key Chest", "Spirit Temple Boss Key Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_TOPMOST_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -29454,                      GI_BOMBS_20,         "Topmost Chest", "Spirit Temple Topmost Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_ENTRANCE_FRONT_LEFT_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  20602,                       GI_BOMBCHUS_10,      "MQ Entrance Front Left Chest", "Spirit Temple MQ Entrance Front Left Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_ENTRANCE_BACK_RIGHT_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -32641,                      GI_BOMBCHUS_10,      "MQ Entrance Back Right Chest", "Spirit Temple MQ Entrance Back Right Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_ENTRANCE_FRONT_RIGHT_CHEST,                 RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30629,                      GI_KEY_SMALL,        "MQ Entrance Front Right Chest", "Spirit Temple MQ Entrance Front Right Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_ENTRANCE_BACK_LEFT_CHEST,                   RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30626,                      GI_KEY_SMALL,        "MQ Entrance Back Left Chest", "Spirit Temple MQ Entrance Back Left Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_CHILD_HAMMER_SWITCH_CHEST,                  RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30627,                      GI_KEY_SMALL,        "MQ Child Hammer Switch Chest", "Spirit Temple MQ Child Hammer Switch Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_MAP_CHEST,                                  RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  2080,                        GI_MAP,              "MQ Map Chest", "Spirit Temple MQ Map Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_MAP_ROOM_ENEMY_CHEST,                       RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  30792,                       GI_KEY_SMALL,        "MQ Map Room Enemy Chest", "Spirit Temple MQ Map Room Enemy Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_CHILD_CLIMB_NORTH_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  28774,                       GI_BOMBCHUS_10,      "MQ Child Climb North Chest", "Spirit Temple MQ Child Climb North Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_CHILD_CLIMB_SOUTH_CHEST,                    RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30644,                      GI_KEY_SMALL,        "MQ Child Climb South Chest", "Spirit Temple MQ Child Climb South Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_COMPASS_CHEST,                              RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -18429,                      GI_COMPASS,          "MQ Compass Chest", "Spirit Temple MQ Compass Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_STATUE_ROOM_LULLABY_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30577,                      GI_MAGIC_LARGE,      "MQ Statue Room Lullaby Chest", "Spirit Temple MQ Statue Room Lullaby Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_STATUE_ROOM_INVISIBLE_CHEST,                RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  26882,                       GI_HEART,            "MQ Statue Room Invisible Chest", "Spirit Temple MQ Statue Room Invisible Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_SILVER_BLOCK_HALLWAY_CHEST,                 RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30628,                      GI_KEY_SMALL,        "MQ Silver Block Hallway Chest", "Spirit Temple MQ Silver Block Hallway Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_SUN_BLOCK_ROOM_CHEST,                       RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  -30463,                      GI_HEART,            "MQ Sun Block Room Chest", "Spirit Temple MQ Sun Block Room Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_SYMPHONY_ROOM_CHEST,                        RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  23207,                       GI_RUPEE_PURPLE,     "MQ Symphony Room Chest", "Spirit Temple MQ Symphony Room Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_LEEVER_ROOM_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  31396,                       GI_RUPEE_PURPLE,     "MQ Leever Room Chest", "Spirit Temple MQ Leever Room Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_BEAMOS_ROOM_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  24472,                       GI_ICE_TRAP,         "MQ Beamos Room Chest", "Spirit Temple MQ Beamos Room Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_CHEST_SWITCH_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  31097,                       GI_ARROWS_LARGE,     "MQ Chest Switch Chest", "Spirit Temple MQ Chest Switch Chest", false),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_BOSS_KEY_CHEST,                             RCVORMQ_MQ,      RCTYPE_BOSS_KEY,                   RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  10213,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Spirit Temple MQ Boss Key Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_MIRROR_PUZZLE_INVISIBLE_CHEST,              RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPIRIT_TEMPLE,                  26706,                       GI_KEY_SMALL,        "MQ Mirror Puzzle Invisible Chest", "Spirit Temple MQ Mirror Puzzle Invisible Chest", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_HALL_AFTER_SUN_BLOCK_ROOM,                  RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9729,                        GI_SKULL_TOKEN,      "GS Hall After Sun Block Room", "Spirit Temple GS Hall After Sun Block Room", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_BOULDER_ROOM,                               RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9730,                        GI_SKULL_TOKEN,      "GS Boulder Room", "Spirit Temple GS Boulder Room", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_LOBBY,                                      RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9732,                        GI_SKULL_TOKEN,      "GS Lobby", "Spirit Temple GS Lobby", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_SUN_ON_FLOOR_ROOM,                          RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9736,                        GI_SKULL_TOKEN,      "GS Sun on Floor Room", "Spirit Temple GS Sun on Floor Room", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_METAL_FENCE,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9744,                        GI_SKULL_TOKEN,      "GS Metal Fence", "Spirit Temple GS Metal Fence", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_SYMPHONY_ROOM,                           RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9736,                        GI_SKULL_TOKEN,      "MQ GS Symphony Room", "Spirit Temple MQ GS Symphony Room", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_LEEVER_ROOM,                             RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9730,                        GI_SKULL_TOKEN,      "MQ GS Leever Room", "Spirit Temple MQ GS Leever Room", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_NINE_THRONES_ROOM_WEST,                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9732,                        GI_SKULL_TOKEN,      "MQ GS Nine Thrones Room West", "Spirit Temple MQ GS Nine Thrones Room West", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_NINE_THRONES_ROOM_NORTH,                 RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9744,                        GI_SKULL_TOKEN,      "MQ GS Nine Thrones Room North", "Spirit Temple MQ GS Nine Thrones Room North", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_SUN_BLOCK_ROOM,                          RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_SPIRIT_TEMPLE,                  9729,                        GI_SKULL_TOKEN,      "MQ GS Sun Block Room", "Spirit Temple MQ GS Sun Block Room", true),
    RC_OBJECT(RC_TWINROVA,                                                    RCVORMQ_BOTH,    RCTYPE_DUNGEON_REWARD,             RCAREA_SPIRIT_TEMPLE,          ACTOR_DOOR_WARP1,   SCENE_SPIRIT_TEMPLE_BOSS,             0x00,                        GI_NONE,             "Twinrova", "Twinrova", true),
    RC_OBJECT(RC_SPIRIT_TEMPLE_TWINROVA_HEART,                                RCVORMQ_BOTH,    RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_SPIRIT_TEMPLE,          ACTOR_ITEM_B_HEART, SCENE_SPIRIT_TEMPLE_BOSS,             0x00,                        GI_HEART_CONTAINER,  "Twinrova Heart Container", "Spirit Temple Twinrova Heart Container", true),

    RC_OBJECT(RC_SHADOW_TEMPLE_MAP_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  6177,                        GI_MAP,              "Map Chest", "Shadow Temple Map Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_HOVER_BOOTS_CHEST,                             RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  5607,                        GI_BOOTS_HOVER,      "Hover Boots Chest", "Shadow Temple Hover Boots Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_COMPASS_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  6147,                        GI_COMPASS,          "Compass Chest", "Shadow Temple Compass Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_EARLY_SILVER_RUPEE_CHEST,                      RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  22594,                       GI_KEY_SMALL,        "Early Silver Rupee Chest", "Shadow Temple Early Silver Rupee Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_INVISIBLE_BLADES_VISIBLE_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  22668,                       GI_MAGIC_LARGE,      "Invisible Blades Visible Chest", "Shadow Temple Invisible Blades Visible Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_INVISIBLE_BLADES_INVISIBLE_CHEST,              RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  26998,                       GI_ARROWS_LARGE,     "Invisible Blades Invisible Chest", "Shadow Temple Invisible Blades Invisible Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_FALLING_SPIKES_LOWER_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  22853,                       GI_ARROWS_MEDIUM,    "Falling Spikes Lower Chest", "Shadow Temple Falling Spikes Lower Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_FALLING_SPIKES_UPPER_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  22662,                       GI_MAGIC_LARGE,      "Falling Spikes Upper Chest", "Shadow Temple Falling Spikes Upper Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_FALLING_SPIKES_SWITCH_CHEST,                   RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  -30652,                      GI_KEY_SMALL,        "Falling Spikes Switch Chest", "Shadow Temple Falling Spikes Switch Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_INVISIBLE_SPIKES_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  30857,                       GI_MAGIC_LARGE,      "Invisible Spikes Chest", "Shadow Temple Invisible Spikes Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_WIND_HINT_CHEST,                               RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  26965,                       GI_ARROWS_MEDIUM,    "Wind Hint Chest", "Shadow Temple Wind Hint Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_AFTER_WIND_ENEMY_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  30856,                       GI_MAGIC_LARGE,      "After Wind Enemy Chest", "Shadow Temple After Wind Enemy Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_AFTER_WIND_HIDDEN_CHEST,                       RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  26708,                       GI_KEY_SMALL,        "After Wind Hidden Chest", "Shadow Temple After Wind Hidden Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_SPIKE_WALLS_LEFT_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  22666,                       GI_MAGIC_LARGE,      "Spike Walls Left Chest", "Shadow Temple Spike Walls Left Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_BOSS_KEY_CHEST,                                RCVORMQ_VANILLA, RCTYPE_BOSS_KEY,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  10219,                       GI_KEY_BOSS,         "Boss Key Chest", "Shadow Temple Boss Key Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_INVISIBLE_FLOORMASTER_CHEST,                   RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  30797,                       GI_KEY_SMALL,        "Invisible Floormaster Chest", "Shadow Temple Invisible Floormaster Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_FREESTANDING_KEY,                              RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_ITEM00,    SCENE_SHADOW_TEMPLE,                  273,                         GI_KEY_SMALL,        "Freestanding Key", "Shadow Temple Freestanding Key", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_COMPASS_CHEST,                              RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  6145,                        GI_COMPASS,          "MQ Compass Chest", "Shadow Temple MQ Compass Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_HOVER_BOOTS_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  5607,                        GI_BOOTS_HOVER,      "MQ Hover Boots Chest", "Shadow Temple MQ Hover Boots Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_EARLY_GIBDOS_CHEST,                         RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  30787,                       GI_KEY_SMALL,        "MQ Early Gibdos Chest", "Shadow Temple MQ Early Gibdos Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_MAP_CHEST,                                  RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  2082,                        GI_MAP,              "MQ Map Chest", "Shadow Temple MQ Map Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_BEAMOS_SILVER_RUPEES_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  -30417,                      GI_ARROWS_SMALL,     "MQ Beamos Silver Rupees Chest", "Shadow Temple MQ Beamos Silver Rupees Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_FALLING_SPIKES_SWITCH_CHEST,                RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  22662,                       GI_MAGIC_LARGE,      "MQ Falling Spikes Switch Chest", "Shadow Temple MQ Falling Spikes Switch Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_FALLING_SPIKES_LOWER_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  22853,                       GI_ARROWS_MEDIUM,    "MQ Falling Spikes Lower Chest", "Shadow Temple MQ Falling Spikes Lower Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_FALLING_SPIKES_UPPER_CHEST,                 RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  -30652,                      GI_KEY_SMALL,        "MQ Falling Spikes Upper Chest", "Shadow Temple MQ Falling Spikes Upper Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_INVISIBLE_SPIKES_CHEST,                     RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  30857,                       GI_MAGIC_LARGE,      "MQ Invisible Spikes Chest", "Shadow Temple MQ Invisible Spikes Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_BOSS_KEY_CHEST,                             RCVORMQ_MQ,      RCTYPE_BOSS_KEY,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  10219,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Shadow Temple MQ Boss Key Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_SPIKE_WALLS_LEFT_CHEST,                     RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  22666,                       GI_KEY_SMALL,        "MQ Spike Walls Left Chest", "Shadow Temple MQ Spike Walls Left Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_STALFOS_ROOM_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  31184,                       GI_RUPEE_RED,        "MQ Stalfos Room Chest", "Shadow Temple MQ Stalfos Room Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_INVISIBLE_BLADES_INVISIBLE_CHEST,           RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  26710,                       GI_KEY_SMALL,        "MQ Invisible Blades Invisible Chest", "Shadow Temple MQ Invisible Blades Invisible Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_INVISIBLE_BLADES_VISIBLE_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  22668,                       GI_MAGIC_LARGE,      "MQ Invisible Blades Visible Chest", "Shadow Temple MQ Invisible Blades Visible Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_BOMB_FLOWER_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  31053,                       GI_ARROWS_MEDIUM,    "MQ Bomb Flower Chest", "Shadow Temple MQ Bomb Flower Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_WIND_HINT_CHEST,                            RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  26709,                       GI_KEY_SMALL,        "MQ Wind Hint Chest", "Shadow Temple MQ Wind Hint Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_AFTER_WIND_HIDDEN_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  26932,                       GI_ARROWS_SMALL,     "MQ After Wind Hidden Chest", "Shadow Temple MQ After Wind Hidden Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_AFTER_WIND_ENEMY_CHEST,                     RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  30856,                       GI_MAGIC_LARGE,      "MQ After Wind Enemy Chest", "Shadow Temple MQ After Wind Enemy Chest", false),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_NEAR_SHIP_INVISIBLE_CHEST,                  RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_SHADOW_TEMPLE,                  26702,                       GI_KEY_SMALL,        "MQ Near Ship Invisible Chest", "Shadow Temple MQ Near Ship Invisible Chest", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_FREESTANDING_KEY,                           RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_ITEM00,    SCENE_SHADOW_TEMPLE,                  1553,                        GI_KEY_SMALL,        "MQ Freestanding Key", "Shadow Temple MQ Freestanding Key", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_SINGLE_GIANT_POT,                           RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  9985,                        GI_SKULL_TOKEN,      "GS Single Giant Pot", "Shadow Temple GS Single Giant Pot", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_FALLING_SPIKES_ROOM,                        RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  9986,                        GI_SKULL_TOKEN,      "GS Falling Spikes Room", "Shadow Temple GS Falling Spikes Room", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_TRIPLE_GIANT_POT,                           RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  9988,                        GI_SKULL_TOKEN,      "GS Triple Giant Pot", "Shadow Temple GS Triple Giant Pot", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_LIKE_LIKE_ROOM,                             RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  9992,                        GI_SKULL_TOKEN,      "GS Like Like Room", "Shadow Temple GS Like Like Room", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_NEAR_SHIP,                                  RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  10000,                       GI_SKULL_TOKEN,      "GS Near Ship", "Shadow Temple GS Near Ship", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_FALLING_SPIKES_ROOM,                     RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  9986,                        GI_SKULL_TOKEN,      "MQ GS Falling Spikes Room", "Shadow Temple MQ GS Falling Spikes Room", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_WIND_HINT_ROOM,                          RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  9985,                        GI_SKULL_TOKEN,      "MQ GS Wind Hint Room", "Shadow Temple MQ GS Wind Hint Room", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_AFTER_WIND,                              RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  9992,                        GI_SKULL_TOKEN,      "MQ GS After Wind", "Shadow Temple MQ GS After Wind", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_AFTER_SHIP,                              RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  10000,                       GI_SKULL_TOKEN,      "MQ GS After Ship", "Shadow Temple MQ GS After Ship", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_NEAR_BOSS,                               RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_SHADOW_TEMPLE,                  9988,                        GI_SKULL_TOKEN,      "MQ GS Near Boss", "Shadow Temple MQ GS Near Boss", true),
    RC_OBJECT(RC_BONGO_BONGO,                                                 RCVORMQ_BOTH,    RCTYPE_DUNGEON_REWARD,             RCAREA_SHADOW_TEMPLE,          ACTOR_DOOR_WARP1,   SCENE_SHADOW_TEMPLE_BOSS,             0x00,                        GI_NONE,             "Bongo Bongo", "Bongo Bongo", true),
    RC_OBJECT(RC_SHADOW_TEMPLE_BONGO_BONGO_HEART,                             RCVORMQ_BOTH,    RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_SHADOW_TEMPLE,          ACTOR_ITEM_B_HEART, SCENE_SHADOW_TEMPLE_BOSS,             0x00,                        GI_HEART_CONTAINER,  "Bongo Bongo Heart Container", "Shadow Temple Bongo Bongo Heart Container", true),

    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_FRONT_LEFT_FAKE_WALL_CHEST,               RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             22600,                       GI_KEY_SMALL,        "Front Left Fake Wall Chest", "Bottom of the Well Front Left Fake Wall Chest", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_FRONT_CENTER_BOMBABLE_CHEST,              RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             20578,                       GI_BOMBCHUS_10,      "Front Center Bombable Chest", "Bottom of the Well Front Center Bombable Chest", false),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_RIGHT_BOTTOM_FAKE_WALL_CHEST,             RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             22597,                       GI_KEY_SMALL,        "Right Bottom Fake Wall Chest", "Bottom of the Well Right Bottom Fake Wall Chest", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_COMPASS_CHEST,                            RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             2049,                        GI_COMPASS,          "Compass Chest", "Bottom of the Well Compass Chest", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_CENTER_SKULLTULA_CHEST,                   RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             20558,                       GI_NUTS_5,           "Center Skulltula Chest", "Bottom of the Well Center Skulltula Chest", false),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_BACK_LEFT_BOMBABLE_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             23684,                       GI_NUTS_10,          "Back Left Bombable Chest", "Bottom of the Well Back Left Bombable Chest", false),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_LENS_OF_TRUTH_CHEST,                      RCVORMQ_VANILLA, RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             4419,                        GI_LENS,             "Lens of Truth Chest", "Bottom of the Well Lens of Truth Chest", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_INVISIBLE_CHEST,                          RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             27348,                       GI_RUPEE_GOLD,       "Invisible Chest", "Bottom of the Well Invisible Chest", false),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_UNDERWATER_FRONT_CHEST,                   RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             23760,                       GI_BOMBS_10,         "Underwater Front Chest", "Bottom of the Well Underwater Front Chest", false),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_UNDERWATER_LEFT_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             22793,                       GI_HEART,            "Underwater Left Chest", "Bottom of the Well Underwater Left Chest", false),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MAP_CHEST,                                RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             2087,                        GI_MAP,              "Map Chest", "Bottom of the Well Map Chest", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_FIRE_KEESE_CHEST,                         RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             21802,                       GI_SHIELD_DEKU,      "Fire Keese Chest", "Bottom of the Well Fire Keese Chest", false),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_LIKE_LIKE_CHEST,                          RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             21836,                       GI_SHIELD_HYLIAN,    "Like Like Chest", "Bottom of the Well Like Like Chest", false),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_FREESTANDING_KEY,                         RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_ITEM00,    SCENE_BOTTOM_OF_THE_WELL,             273,                         GI_KEY_SMALL,        "Freestanding Key", "Bottom of the Well Freestanding Key", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_MAP_CHEST,                             RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             2083,                        GI_MAP,              "MQ Map Chest", "Bottom of the Well MQ Map Chest", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_LENS_OF_TRUTH_CHEST,                   RCVORMQ_MQ,      RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             -20159,                      GI_LENS,             "MQ Lens of Truth Chest", "Bottom of the Well MQ Lens of Truth Chest", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_COMPASS_CHEST,                         RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_BOTTOM_OF_THE_WELL,             6146,                        GI_COMPASS,          "MQ Compass Chest", "Bottom of the Well MQ Compass Chest", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_DEAD_HAND_FREESTANDING_KEY,            RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_ITEM00,    SCENE_BOTTOM_OF_THE_WELL,             529,                         GI_KEY_SMALL,        "MQ Dead Hand Freestanding Key", "Bottom of the Well MQ Dead Hand Freestanding Key", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_EAST_INNER_ROOM_FREESTANDING_KEY,      RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_ITEM00,    SCENE_BOTTOM_OF_THE_WELL,             273,                         GI_KEY_SMALL,        "MQ East Inner Room Freestanding Key", "Bottom of the Well MQ East Inner Room Freestanding Key", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_GS_LIKE_LIKE_CAGE,                        RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_BOTTOM_OF_THE_WELL,             10241,                       GI_SKULL_TOKEN,      "GS Like Like Cage", "Bottom of the Well GS Like Like Cage", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_GS_EAST_INNER_ROOM,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_BOTTOM_OF_THE_WELL,             10242,                       GI_SKULL_TOKEN,      "GS East Inner Room", "Bottom of the Well GS East Inner Room", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_GS_WEST_INNER_ROOM,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_BOTTOM_OF_THE_WELL,             10244,                       GI_SKULL_TOKEN,      "GS West Inner Room", "Bottom of the Well GS West Inner Room", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_GS_BASEMENT,                           RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_BOTTOM_OF_THE_WELL,             10241,                       GI_SKULL_TOKEN,      "MQ GS Basement", "Bottom of the Well MQ GS Basement", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_GS_COFFIN_ROOM,                        RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_BOTTOM_OF_THE_WELL,             10244,                       GI_SKULL_TOKEN,      "MQ GS Coffin Room", "Bottom of the Well MQ GS Coffin Room", true),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_GS_WEST_INNER_ROOM,                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_BOTTOM_OF_THE_WELL,             10242,                       GI_SKULL_TOKEN,      "MQ GS West Inner Room", "Bottom of the Well MQ GS West Inner Room", true),

    RC_OBJECT(RC_ICE_CAVERN_MAP_CHEST,                                        RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_CAVERN,                     2080,                        GI_MAP,              "Map Chest", "Ice Cavern Map Chest", true),
    RC_OBJECT(RC_ICE_CAVERN_COMPASS_CHEST,                                    RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,                RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_CAVERN,                     2049,                        GI_COMPASS,          "Compass Chest", "Ice Cavern Compass Chest", true),
    RC_OBJECT(RC_ICE_CAVERN_IRON_BOOTS_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_CAVERN,                     5570,                        GI_BOOTS_IRON,       "Iron Boots Chest", "Ice Cavern Iron Boots Chest", true),
    RC_OBJECT(RC_ICE_CAVERN_FREESTANDING_POH,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_ICE_CAVERN,             ACTOR_EN_ITEM00,    SCENE_ICE_CAVERN,                     262,                         GI_HEART_PIECE,      "Freestanding PoH", "Ice Cavern Freestanding PoH", true),
    RC_OBJECT(RC_ICE_CAVERN_MQ_IRON_BOOTS_CHEST,                              RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_CAVERN,                     5570,                        GI_BOOTS_IRON,       "MQ Iron Boots Chest", "Ice Cavern MQ Iron Boots Chest", true),
    RC_OBJECT(RC_ICE_CAVERN_MQ_COMPASS_CHEST,                                 RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_CAVERN,                     2048,                        GI_COMPASS,          "MQ Compass Chest", "Ice Cavern MQ Compass Chest", true),
    RC_OBJECT(RC_ICE_CAVERN_MQ_MAP_CHEST,                                     RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,                RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_CAVERN,                     -18399,                      GI_MAP,              "MQ Map Chest", "Ice Cavern MQ Map Chest", true),
    RC_OBJECT(RC_ICE_CAVERN_MQ_FREESTANDING_POH,                              RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_ICE_CAVERN,             ACTOR_EN_ITEM00,    SCENE_ICE_CAVERN,                     262,                         GI_HEART_PIECE,      "MQ Freestanding PoH", "Ice Cavern MQ Freestanding PoH", true),
    RC_OBJECT(RC_ICE_CAVERN_GS_PUSH_BLOCK_ROOM,                               RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_CAVERN,                     10497,                       GI_SKULL_TOKEN,      "GS Push Block Room", "Ice Cavern GS Push Block Room", true),
    RC_OBJECT(RC_ICE_CAVERN_GS_SPINNING_SCYTHE_ROOM,                          RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_CAVERN,                     10498,                       GI_SKULL_TOKEN,      "GS Spinning Scythe Room", "Ice Cavern GS Spinning Scythe Room", true),
    RC_OBJECT(RC_ICE_CAVERN_GS_HEART_PIECE_ROOM,                              RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,                RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_CAVERN,                     10500,                       GI_SKULL_TOKEN,      "GS Heart Piece Room", "Ice Cavern GS Heart Piece Room", true),
    RC_OBJECT(RC_ICE_CAVERN_MQ_GS_SCARECROW,                                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_CAVERN,                     10497,                       GI_SKULL_TOKEN,      "MQ GS Scarecrow", "Ice Cavern MQ GS Scarecrow", true),
    RC_OBJECT(RC_ICE_CAVERN_MQ_GS_ICE_BLOCK,                                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_CAVERN,                     10500,                       GI_SKULL_TOKEN,      "MQ GS Ice Block", "Ice Cavern MQ GS Ice Block", true),
    RC_OBJECT(RC_ICE_CAVERN_MQ_GS_RED_ICE,                                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,                RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_CAVERN,                     10498,                       GI_SKULL_TOKEN,      "MQ GS Red Ice", "Ice Cavern MQ GS Red Ice", true),
    RC_OBJECT(RC_SHEIK_IN_ICE_CAVERN,                                         RCVORMQ_BOTH,    RCTYPE_SONG_LOCATION,              RCAREA_ICE_CAVERN,             ACTOR_ID_MAX,       SCENE_ICE_CAVERN,                     0x00,                        GI_NONE,             "Sheik in Ice Cavern", "Sheik in Ice Cavern", true),

    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_LOBBY_LEFT_CHEST,                     RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30573,                      GI_MAGIC_LARGE,      "Lobby Left Chest", "Gerudo Training Grounds Lobby Left Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_LOBBY_RIGHT_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30393,                      GI_ARROWS_MEDIUM,    "Lobby Right Chest", "Gerudo Training Grounds Lobby Right Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_STALFOS_CHEST,                        RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30656,                      GI_KEY_SMALL,        "Stalfos Chest", "Gerudo Training Grounds Stalfos Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_BEAMOS_CHEST,                         RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30655,                      GI_KEY_SMALL,        "Beamos Chest", "Gerudo Training Grounds Beamos Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HIDDEN_CEILING_CHEST,                 RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22603,                       GI_KEY_SMALL,        "Hidden Ceiling Chest", "Gerudo Training Grounds Hidden Ceiling Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_PATH_FIRST_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         23206,                       GI_RUPEE_PURPLE,     "Maze Path First Chest", "Gerudo Training Grounds Maze Path First Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_PATH_SECOND_CHEST,               RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22986,                       GI_RUPEE_RED,        "Maze Path Second Chest", "Gerudo Training Grounds Maze Path Second Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_PATH_THIRD_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22889,                       GI_ARROWS_LARGE,     "Maze Path Third Chest", "Gerudo Training Grounds Maze Path Third Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_PATH_FINAL_CHEST,                RCVORMQ_VANILLA, RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         2860,                        GI_ARROW_ICE,        "Maze Path Final Chest", "Gerudo Training Grounds Maze Path Final Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_RIGHT_CENTRAL_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         23877,                       GI_BOMBCHUS_5,       "Maze Right Central Chest", "Gerudo Training Grounds Maze Right Central Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_RIGHT_SIDE_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22888,                       GI_ARROWS_LARGE,     "Maze Right Side Chest", "Gerudo Training Grounds Maze Right Side Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_UNDERWATER_SILVER_RUPEE_CHEST,        RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30643,                      GI_KEY_SMALL,        "Underwater Silver Rupee Chest", "Gerudo Training Grounds Underwater Silver Rupee Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HAMMER_ROOM_CLEAR_CHEST,              RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         31058,                       GI_ARROWS_MEDIUM,    "Hammer Room Clear Chest", "Gerudo Training Grounds Hammer Room Clear Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HAMMER_ROOM_SWITCH_CHEST,             RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22608,                       GI_KEY_SMALL,        "Hammer Room Switch Chest", "Gerudo Training Grounds Hammer Room Switch Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_EYE_STATUE_CHEST,                     RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30653,                      GI_KEY_SMALL,        "Eye Statue Chest", "Gerudo Training Grounds Eye Statue Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_NEAR_SCARECROW_CHEST,                 RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22596,                       GI_KEY_SMALL,        "Near Scarecrow Chest", "Gerudo Training Grounds Near Scarecrow Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_BEFORE_HEAVY_BLOCK_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         31089,                       GI_ARROWS_LARGE,     "Before Heavy Block Chest", "Gerudo Training Grounds Before Heavy Block Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HEAVY_BLOCK_FIRST_CHEST,              RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         31439,                       GI_RUPEE_GOLD,       "Heavy Block First Chest", "Gerudo Training Grounds Heavy Block First Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HEAVY_BLOCK_SECOND_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         30862,                       GI_MAGIC_LARGE,      "Heavy Block Second Chest", "Gerudo Training Grounds Heavy Block Second Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HEAVY_BLOCK_THIRD_CHEST,              RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         26708,                       GI_KEY_SMALL,        "Heavy Block Third Chest", "Gerudo Training Grounds Heavy Block Third Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HEAVY_BLOCK_FOURTH_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         24450,                       GI_ICE_TRAP,         "Heavy Block Fourth Chest", "Gerudo Training Grounds Heavy Block Fourth Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_FREESTANDING_KEY,                     RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_ITEM00,    SCENE_GERUDO_TRAINING_GROUND,         273,                         GI_KEY_SMALL,        "Freestanding Key", "Gerudo Training Grounds Freestanding Key", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_LOBBY_RIGHT_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         23879,                       GI_BOMBCHUS_5,       "MQ Lobby Right Chest", "Gerudo Training Grounds MQ Lobby Right Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_LOBBY_LEFT_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22867,                       GI_ARROWS_MEDIUM,    "MQ Lobby Left Chest", "Gerudo Training Grounds MQ Lobby Left Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_FIRST_IRON_KNUCKLE_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30304,                      GI_RUPEE_BLUE,       "MQ First Iron Knuckle Chest", "Gerudo Training Grounds MQ First Iron Knuckle Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_BEFORE_HEAVY_BLOCK_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         31057,                       GI_ARROWS_MEDIUM,    "MQ Before Heavy Block Chest", "Gerudo Training Grounds MQ Before Heavy Block Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_EYE_STATUE_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -32669,                      GI_BOMBCHUS_10,      "MQ Eye Statue Chest", "Gerudo Training Grounds MQ Eye Statue Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_FLAME_CIRCLE_CHEST,                RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30642,                      GI_KEY_SMALL,        "MQ Flame Circle Chest", "Gerudo Training Grounds MQ Flame Circle Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_SECOND_IRON_KNUCKLE_CHEST,         RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         31058,                       GI_ARROWS_MEDIUM,    "MQ Second Iron Knuckle Chest", "Gerudo Training Grounds MQ Second Iron Knuckle Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_DINOLFOS_CHEST,                    RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30655,                      GI_KEY_SMALL,        "MQ Dinolfos Chest", "Gerudo Training Grounds MQ Dinolfos Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_ICE_ARROWS_CHEST,                  RCVORMQ_MQ,      RCTYPE_BOSS_HEART_OR_OTHER_REWARD, RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -17628,                      GI_ARROW_ICE,        "MQ Ice Arrows Chest", "Gerudo Training Grounds MQ Ice Arrows Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_RIGHT_CENTRAL_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22661,                       GI_MAGIC_LARGE,      "MQ Maze Right Central Chest", "Gerudo Training Grounds MQ Maze Right Central Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_PATH_FIRST_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22918,                       GI_RUPEE_GREEN,      "MQ Maze Path First Chest", "Gerudo Training Grounds MQ Maze Path First Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_RIGHT_SIDE_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         24136,                       GI_RUPEE_GREEN_LOSE, "MQ Maze Right Side Chest", "Gerudo Training Grounds MQ Maze Right Side Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_PATH_THIRD_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         24137,                       GI_RUPEE_GREEN_LOSE, "MQ Maze Path Third Chest", "Gerudo Training Grounds MQ Maze Path Third Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_PATH_SECOND_CHEST,            RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         22986,                       GI_RUPEE_RED,        "MQ Maze Path Second Chest", "Gerudo Training Grounds MQ Maze Path Second Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_HIDDEN_CEILING_CHEST,              RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         23211,                       GI_RUPEE_PURPLE,     "MQ Hidden Ceiling Chest", "Gerudo Training Grounds MQ Hidden Ceiling Chest", false),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_UNDERWATER_SILVER_RUPEE_CHEST,     RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         -30643,                      GI_KEY_SMALL,        "MQ Underwater Silver Rupee Chest", "Gerudo Training Grounds MQ Underwater Silver Rupee Chest", true),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_HEAVY_BLOCK_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_GERUDO_TRAINING_GROUND,         31394,                       GI_RUPEE_PURPLE,     "MQ Heavy Block Chest", "Gerudo Training Grounds MQ Heavy Block Chest", false),

    RC_OBJECT(RC_GANONS_TOWER_BOSS_KEY_CHEST,                                 RCVORMQ_BOTH,    RCTYPE_GANON_BOSS_KEY,             RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONS_TOWER,                   10219,                       GI_KEY_BOSS,         "Boss Key Chest", "Ganon's Tower Boss Key Chest", true),
    RC_OBJECT(RC_GANONS_CASTLE_FOREST_TRIAL_CHEST,                            RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           30857,                       GI_MAGIC_LARGE,      "Forest Trial Chest", "Ganon's Castle Forest Trial Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_WATER_TRIAL_LEFT_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           24455,                       GI_ICE_TRAP,         "Water Trial Left Chest", "Ganon's Castle Water Trial Left Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_WATER_TRIAL_RIGHT_CHEST,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           22790,                       GI_HEART,            "Water Trial Right Chest", "Ganon's Castle Water Trial Right Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_SHADOW_TRIAL_FRONT_CHEST,                      RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           22664,                       GI_MAGIC_LARGE,      "Shadow Trial Front Chest", "Ganon's Castle Shadow Trial Front Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_SHADOW_TRIAL_GOLDEN_GAUNTLETS_CHEST,           RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           14021,                       GI_GAUNTLETS_GOLD,   "Shadow Trial Golden Gauntlets Chest", "Ganon's Castle Shadow Trial Golden Gauntlets Chest", true),
    RC_OBJECT(RC_GANONS_CASTLE_SPIRIT_TRIAL_CRYSTAL_SWITCH_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -29326,                      GI_BOMBCHUS_20,      "Spirit Trial Crystal Switch Chest", "Ganon's Castle Spirit Trial Crystal Switch Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_SPIRIT_TRIAL_INVISIBLE_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           26964,                       GI_ARROWS_MEDIUM,    "Spirit Trial Invisible Chest", "Ganon's Castle Spirit Trial Invisible Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_FIRST_LEFT_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           22668,                       GI_MAGIC_LARGE,      "Light Trial First Left Chest", "Ganon's Castle Light Trial First Left Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_SECOND_LEFT_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           24459,                       GI_ICE_TRAP,         "Light Trial Second Left Chest", "Ganon's Castle Light Trial Second Left Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_THIRD_LEFT_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           22797,                       GI_HEART,            "Light Trial Third Left Chest", "Ganon's Castle Light Trial Third Left Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_FIRST_RIGHT_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           24462,                       GI_ICE_TRAP,         "Light Trial First Right Chest", "Ganon's Castle Light Trial First Right Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_SECOND_RIGHT_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           22890,                       GI_ARROWS_LARGE,     "Light Trial Second Right Chest", "Ganon's Castle Light Trial Second Right Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_THIRD_RIGHT_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           24463,                       GI_ICE_TRAP,         "Light Trial Third Right Chest", "Ganon's Castle Light Trial Third Right Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_INVISIBLE_ENEMIES_CHEST,           RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           30800,                       GI_KEY_SMALL,        "Light Trial Invisible Enemies Chest", "Ganon's Castle Light Trial Invisible Enemies Chest", true),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_LULLABY_CHEST,                     RCVORMQ_VANILLA, RCTYPE_SMALL_KEY,                  RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -30639,                      GI_KEY_SMALL,        "Light Trial Lullaby Chest", "Ganon's Castle Light Trial Lullaby Chest", true),
    RC_OBJECT(RC_GANONS_CASTLE_DEKU_SCRUB_CENTER_LEFT,                        RCVORMQ_VANILLA, RCTYPE_SCRUB,                      RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_INSIDE_GANONS_CASTLE,           0x05,                        GI_BOMBS_5,          "Deku Scrub Center-Left", "Ganon's Castle Deku Scrub Center-Left", false),
    RC_OBJECT(RC_GANONS_CASTLE_DEKU_SCRUB_CENTER_RIGHT,                       RCVORMQ_VANILLA, RCTYPE_SCRUB,                      RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_INSIDE_GANONS_CASTLE,           0x03,                        GI_SEEDS_30,         "Deku Scrub Center-Right", "Ganon's Castle Deku Scrub Center-Right", false),
    RC_OBJECT(RC_GANONS_CASTLE_DEKU_SCRUB_RIGHT,                              RCVORMQ_VANILLA, RCTYPE_SCRUB,                      RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_INSIDE_GANONS_CASTLE,           0x07,                        GI_POTION_RED,       "Deku Scrub Right", "Ganon's Castle Deku Scrub Right", false),
    RC_OBJECT(RC_GANONS_CASTLE_DEKU_SCRUB_LEFT,                               RCVORMQ_VANILLA, RCTYPE_SCRUB,                      RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_INSIDE_GANONS_CASTLE,           0x08,                        GI_POTION_GREEN,     "Deku Scrub Left", "Ganon's Castle Deku Scrub Left", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_WATER_TRIAL_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           22977,                       GI_RUPEE_RED,        "MQ Water Trial Chest", "Ganon's Castle MQ Water Trial Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_FOREST_TRIAL_EYE_SWITCH_CHEST,              RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -30398,                      GI_ARROWS_MEDIUM,    "MQ Forest Trial Eye Switch Chest", "Ganon's Castle MQ Forest Trial Eye Switch Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_FOREST_TRIAL_FROZEN_EYE_SWITCH_CHEST,       RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -32733,                      GI_BOMBS_5,          "MQ Forest Trial Frozen Eye Switch Chest", "Ganon's Castle MQ Forest Trial Frozen Eye Switch Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_LIGHT_TRIAL_LULLABY_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -30460,                      GI_HEART,            "MQ Light Trial Lullaby Chest", "Ganon's Castle MQ Light Trial Lullaby Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SHADOW_TRIAL_BOMB_FLOWER_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -30400,                      GI_ARROWS_MEDIUM,    "MQ Shadow Trial Bomb Flower Chest", "Ganon's Castle MQ Shadow Trial Bomb Flower Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SHADOW_TRIAL_EYE_SWITCH_CHEST,              RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -30651,                      GI_KEY_SMALL,        "MQ Shadow Trial Eye Switch Chest", "Ganon's Castle MQ Shadow Trial Eye Switch Chest", true),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_GOLDEN_GAUNTLETS_CHEST,        RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -18746,                      GI_GAUNTLETS_GOLD,   "MQ Spirit Trial Golden Gauntlets Chest", "Ganon's Castle MQ Spirit Trial Golden Gauntlets Chest", true),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_SUN_BACK_RIGHT_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -30457,                      GI_HEART,            "MQ Spirit Trial Sun Back Right Chest", "Ganon's Castle MQ Spirit Trial Sun Back Right Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_SUN_BACK_LEFT_CHEST,           RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -30648,                      GI_KEY_SMALL,        "MQ Spirit Trial Sun Back Left Chest", "Ganon's Castle MQ Spirit Trial Sun Back Left Chest", true),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_SUN_FRONT_LEFT_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           -30455,                      GI_HEART,            "MQ Spirit Trial Sun Front Left Chest", "Ganon's Castle MQ Spirit Trial Sun Front Left Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_FIRST_CHEST,                   RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           20586,                       GI_BOMBCHUS_10,      "MQ Spirit Trial First Chest", "Ganon's Castle MQ Spirit Trial First Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_INVISIBLE_CHEST,               RCVORMQ_MQ,      RCTYPE_STANDARD,                   RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_INSIDE_GANONS_CASTLE,           26964,                       GI_ARROWS_MEDIUM,    "MQ Spirit Trial Invisible Chest", "Ganon's Castle MQ Spirit Trial Invisible Chest", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_FOREST_TRIAL_FREESTANDING_KEY,              RCVORMQ_MQ,      RCTYPE_SMALL_KEY,                  RCAREA_GANONS_CASTLE,          ACTOR_EN_ITEM00,    SCENE_INSIDE_GANONS_CASTLE,           273,                         GI_KEY_SMALL,        "MQ Forest Trial Freestanding Key", "Ganon's Castle MQ Forest Trial Freestanding Key", true),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_RIGHT,                           RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_INSIDE_GANONS_CASTLE,           0x00,                        GI_NUTS_5_2,         "MQ Deku Scrub Right", "Ganon's Castle MQ Deku Scrub Right", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_CENTER_LEFT,                     RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_INSIDE_GANONS_CASTLE,           0x05,                        GI_BOMBS_5,          "MQ Deku Scrub Center-Left", "Ganon's Castle MQ Deku Scrub Center-Left", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_CENTER,                          RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_INSIDE_GANONS_CASTLE,           0x03,                        GI_SEEDS_30,         "MQ Deku Scrub Center", "Ganon's Castle MQ Deku Scrub Center", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_CENTER_RIGHT,                    RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_INSIDE_GANONS_CASTLE,           0x07,                        GI_POTION_RED,       "MQ Deku Scrub Center-Right", "Ganon's Castle MQ Deku Scrub Center-Right", false),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_LEFT,                            RCVORMQ_MQ,      RCTYPE_SCRUB,                      RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_INSIDE_GANONS_CASTLE,           0x08,                        GI_POTION_GREEN,     "MQ Deku Scrub Left", "Ganon's Castle MQ Deku Scrub Left", false),

    RC_OBJECT(RC_UNKNOWN_CHECK,                                               RCVORMQ_BOTH,    RCTYPE_STANDARD,                   RCAREA_INVALID,                ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Invalid Check", "Invalid Check", false),
};

std::map<RandomizerCheckArea, std::string> rcAreaNames = {
    { RCAREA_KOKIRI_FOREST, "Kokiri Forest"},
    { RCAREA_LOST_WOODS, "Lost Woods"},
    { RCAREA_SACRED_FOREST_MEADOW, "Sacred Forest Meadow"},
    { RCAREA_HYRULE_FIELD, "Hyrule Field"},
    { RCAREA_LAKE_HYLIA, "Lake Hylia"},
    { RCAREA_GERUDO_VALLEY, "Gerudo Valley"},
    { RCAREA_GERUDO_FORTRESS, "Gerudo Fortress"},
    { RCAREA_WASTELAND, "Haunted Wasteland"},
    { RCAREA_DESERT_COLOSSUS, "Desert Colossus"},
    { RCAREA_MARKET, "Hyrule Market"},
    { RCAREA_HYRULE_CASTLE, "Hyrule Castle"},
    { RCAREA_KAKARIKO_VILLAGE, "Kakariko Village"},
    { RCAREA_GRAVEYARD, "Graveyard"},
    { RCAREA_DEATH_MOUNTAIN_TRAIL, "Death Mountain Trail"},
    { RCAREA_GORON_CITY, "Goron City"},
    { RCAREA_DEATH_MOUNTAIN_CRATER, "Death Mountain Crater"},
    { RCAREA_ZORAS_RIVER, "Zora's River"},
    { RCAREA_ZORAS_DOMAIN, "Zora's Domain"},
    { RCAREA_ZORAS_FOUNTAIN, "Zora's Fountain"},
    { RCAREA_LON_LON_RANCH, "Lon Lon Ranch"},
    { RCAREA_DEKU_TREE, "Deku Tree"},
    { RCAREA_DODONGOS_CAVERN, "Dodongo's Cavern"},
    { RCAREA_JABU_JABUS_BELLY, "Jabu Jabu's Belly"},
    { RCAREA_FOREST_TEMPLE, "Forest Temple"},
    { RCAREA_FIRE_TEMPLE, "Fire Temple"},
    { RCAREA_WATER_TEMPLE, "Water Temple"},
    { RCAREA_SPIRIT_TEMPLE, "Spirit Temple"},
    { RCAREA_SHADOW_TEMPLE, "Shadow Temple"},
    { RCAREA_BOTTOM_OF_THE_WELL, "Bottom of the Well"},
    { RCAREA_ICE_CAVERN, "Ice Cavern"},
    { RCAREA_GERUDO_TRAINING_GROUND, "Gerudo Training Grounds"},
    { RCAREA_GANONS_CASTLE, "Ganon's Castle"},
    { RCAREA_INVALID, "Invalid"},
 };

std::map<RandomizerCheckArea, std::map<RandomizerCheck, RandomizerCheckObject*>> rcObjectsByArea = {};

std::map<RandomizerCheckArea, std::map<RandomizerCheck, RandomizerCheckObject*>> RandomizerCheckObjects::GetAllRCObjectsByArea() {
    if (rcObjectsByArea.size() == 0) {
        for (auto& [randomizerCheck, rcObject] : rcObjects) {
            rcObjectsByArea[rcObject.rcArea][randomizerCheck] = &rcObject;
        }
    }

    return rcObjectsByArea;
}

bool RandomizerCheckObjects::AreaIsDungeon(RandomizerCheckArea area) {
    return area == RCAREA_GANONS_CASTLE ||
           area == RCAREA_GERUDO_TRAINING_GROUND ||
           area == RCAREA_ICE_CAVERN ||
           area == RCAREA_BOTTOM_OF_THE_WELL ||
           area == RCAREA_SHADOW_TEMPLE ||
           area == RCAREA_SPIRIT_TEMPLE ||
           area == RCAREA_WATER_TEMPLE ||
           area == RCAREA_FIRE_TEMPLE ||
           area == RCAREA_FOREST_TEMPLE ||
           area == RCAREA_JABU_JABUS_BELLY ||
           area == RCAREA_DODONGOS_CAVERN ||
           area == RCAREA_DEKU_TREE;
}

bool RandomizerCheckObjects::AreaIsOverworld(RandomizerCheckArea area) {
    return !AreaIsDungeon(area);
}

std::string RandomizerCheckObjects::GetRCAreaName(RandomizerCheckArea area) {
    return rcAreaNames[area];
}

std::map<RandomizerCheck, RandomizerCheckObject> RandomizerCheckObjects::GetAllRCObjects() {
    return rcObjects;
}

std::map<SceneID, RandomizerCheckArea> rcAreaBySceneID = {};
std::map<SceneID, RandomizerCheckArea> RandomizerCheckObjects::GetAllRCAreaBySceneID() {
    //memoize on first request
    if (rcAreaBySceneID.size() == 0) {
        for (auto& [randomizerCheck, rcObject] : rcObjects) {
            rcAreaBySceneID[rcObject.sceneId] = rcObject.rcArea;
        }
        //Add checkless Hyrule Market areas to the area return
        for (int id = (int)SCENE_MARKET_ENTRANCE_DAY; id <= (int)SCENE_MARKET_RUINS; id++) {
            rcAreaBySceneID[(SceneID)id] = RCAREA_MARKET;
        }
        rcAreaBySceneID[SCENE_TEMPLE_OF_TIME] = RCAREA_MARKET;
        rcAreaBySceneID[SCENE_CASTLE_COURTYARD_GUARDS_DAY] = RCAREA_HYRULE_CASTLE;
        rcAreaBySceneID[SCENE_CASTLE_COURTYARD_GUARDS_NIGHT] = RCAREA_HYRULE_CASTLE;
    }
    return rcAreaBySceneID;
}

RandomizerCheckArea RandomizerCheckObjects::GetRCAreaBySceneID(SceneID sceneId) {
    std::map<SceneID, RandomizerCheckArea> areas = GetAllRCAreaBySceneID();
    auto areaIt = areas.find(sceneId);
    if (areaIt == areas.end())
        return RCAREA_INVALID;
    else
        return areaIt->second;
}

void RandomizerCheckObjects::UpdateImGuiVisibility() {
    for (auto& [randomizerCheck, locationIt] : rcObjects) {
        locationIt.visibleInImgui = (
            (locationIt.rc != RC_UNKNOWN_CHECK) &&
            (!RandomizerCheckObjects::AreaIsDungeon(locationIt.rcArea) ||
                locationIt.vOrMQ == RCVORMQ_BOTH ||
                locationIt.vOrMQ == RCVORMQ_MQ &&
                    ((CVarGetInteger("gRandomizeMqDungeons", RO_MQ_DUNGEONS_NONE) == RO_MQ_DUNGEONS_SET_NUMBER && (CVarGetInteger("gRandomizeMqDungeonCount", 12) > 0) || // at least one MQ dungeon
                      CVarGetInteger("gRandomizeMqDungeons", RO_MQ_DUNGEONS_NONE) == RO_MQ_DUNGEONS_RANDOM_NUMBER)) ||
                locationIt.vOrMQ == RCVORMQ_VANILLA &&
                    (CVarGetInteger("gRandomizeMqDungeons", RO_MQ_DUNGEONS_NONE) != RO_MQ_DUNGEONS_SET_NUMBER || CVarGetInteger("gRandomizeMqDungeonCount", 12) < 12) // at least one vanilla dungeon
            ) &&
            (locationIt.rcType != RCTYPE_SHOP || CVarGetInteger("gRandomizeShopsanity", RO_SHOPSANITY_OFF) > RO_SHOPSANITY_ZERO_ITEMS) &&
            (locationIt.rcType != RCTYPE_SCRUB || CVarGetInteger("gRandomizeShuffleScrubs", RO_SCRUBS_OFF) != RO_SCRUBS_OFF ||
                locationIt.rc == RC_HF_DEKU_SCRUB_GROTTO || locationIt.rc == RC_LW_DEKU_SCRUB_GROTTO_FRONT || locationIt.rc == RC_LW_DEKU_SCRUB_NEAR_BRIDGE) && // The 3 scrubs that are always randomized
            (locationIt.rcType != RCTYPE_MERCHANT || CVarGetInteger("gRandomizeShuffleMerchants", RO_SHUFFLE_MERCHANTS_OFF) != RO_SHUFFLE_MERCHANTS_OFF) &&
            (locationIt.rcType != RCTYPE_SONG_LOCATION || CVarGetInteger("gRandomizeShuffleSongs", RO_SONG_SHUFFLE_SONG_LOCATIONS) != RO_SONG_SHUFFLE_SONG_LOCATIONS) && // song locations
            ((locationIt.rcType != RCTYPE_BOSS_HEART_OR_OTHER_REWARD && locationIt.rc != RC_SONG_FROM_IMPA && locationIt.rc != RC_SHEIK_IN_ICE_CAVERN) ||
                CVarGetInteger("gRandomizeShuffleSongs", RO_SONG_SHUFFLE_SONG_LOCATIONS) != RO_SONG_SHUFFLE_DUNGEON_REWARDS) && // song dungeon rewards
            (locationIt.rcType != RCTYPE_DUNGEON_REWARD || CVarGetInteger("gRandomizeShuffleDungeonReward", RO_DUNGEON_REWARDS_END_OF_DUNGEON) != RO_DUNGEON_REWARDS_END_OF_DUNGEON) && // dungeon rewards end of dungeons
            (locationIt.rcType != RCTYPE_OCARINA || CVarGetInteger("gRandomizeShuffleOcarinas", RO_GENERIC_NO)) && // ocarina locations
            (locationIt.rc != RC_HC_ZELDAS_LETTER) && // don't show until we support shuffling letter
            (locationIt.rcType != RCTYPE_GOSSIP_STONE) && // don't show gossip stones (maybe gossipsanity will be a thing eventually?)
            (locationIt.rcType != RCTYPE_LINKS_POCKET) && // links pocket can be set to nothing if needed
            (locationIt.rcType != RCTYPE_CHEST_GAME) && // don't show non final reward chest game checks until we support shuffling them
            (locationIt.rcType != RCTYPE_SKULL_TOKEN ||
                (CVarGetInteger("gRandomizeShuffleTokens", RO_TOKENSANITY_OFF) == RO_TOKENSANITY_ALL) ||
                ((CVarGetInteger("gRandomizeShuffleTokens", RO_TOKENSANITY_OFF) == RO_TOKENSANITY_OVERWORLD) && RandomizerCheckObjects::AreaIsOverworld(locationIt.rcArea)) ||
                ((CVarGetInteger("gRandomizeShuffleTokens", RO_TOKENSANITY_OFF) == RO_TOKENSANITY_DUNGEONS) && RandomizerCheckObjects::AreaIsDungeon(locationIt.rcArea))
            ) &&
            (locationIt.rcType != RCTYPE_COW || CVarGetInteger("gRandomizeShuffleCows", RO_GENERIC_NO)) &&
            (locationIt.rcType != RCTYPE_ADULT_TRADE || CVarGetInteger("gRandomizeShuffleAdultTrade", RO_GENERIC_NO)) &&
            (locationIt.rc != RC_KF_KOKIRI_SWORD_CHEST || CVarGetInteger("gRandomizeShuffleKokiriSword", RO_GENERIC_NO)) &&
            (locationIt.rc != RC_ZR_MAGIC_BEAN_SALESMAN || CVarGetInteger("gRandomizeShuffleBeans", RO_GENERIC_NO)) &&
            (locationIt.rc != RC_HC_MALON_EGG || CVarGetInteger("gRandomizeShuffleWeirdEgg", RO_GENERIC_NO)) &&
            (locationIt.rcType != RCTYPE_FROG_SONG || CVarGetInteger("gRandomizeShuffleFrogSongRupees", RO_GENERIC_NO)) &&
            (locationIt.rcType != RCTYPE_MAP_COMPASS || CVarGetInteger("gRandomizeStartingMapsCompasses", RO_DUNGEON_ITEM_LOC_OWN_DUNGEON) != RO_DUNGEON_ITEM_LOC_VANILLA) &&
            (locationIt.rcType != RCTYPE_SMALL_KEY || CVarGetInteger("gRandomizeKeysanity", RO_DUNGEON_ITEM_LOC_OWN_DUNGEON) != RO_DUNGEON_ITEM_LOC_VANILLA) &&
            (locationIt.rcType != RCTYPE_BOSS_KEY || CVarGetInteger("gRandomizeBossKeysanity", RO_DUNGEON_ITEM_LOC_OWN_DUNGEON) != RO_DUNGEON_ITEM_LOC_VANILLA) &&
            (locationIt.rcType != RCTYPE_GANON_BOSS_KEY || CVarGetInteger("gRandomizeShuffleGanonBossKey", RO_GANON_BOSS_KEY_VANILLA) != RO_GANON_BOSS_KEY_VANILLA) && // vanilla ganon boss key
            (locationIt.rc != RC_TOT_LIGHT_ARROWS_CUTSCENE ||
                (CVarGetInteger("gRandomizeShuffleGanonBossKey", RO_GANON_BOSS_KEY_VANILLA) != RO_GANON_BOSS_KEY_LACS_DUNGEONS &&
                CVarGetInteger("gRandomizeShuffleGanonBossKey", RO_GANON_BOSS_KEY_VANILLA) != RO_GANON_BOSS_KEY_LACS_MEDALLIONS &&
                CVarGetInteger("gRandomizeShuffleGanonBossKey", RO_GANON_BOSS_KEY_VANILLA) != RO_GANON_BOSS_KEY_LACS_REWARDS &&
                CVarGetInteger("gRandomizeShuffleGanonBossKey", RO_GANON_BOSS_KEY_VANILLA) != RO_GANON_BOSS_KEY_LACS_STONES &&
                CVarGetInteger("gRandomizeShuffleGanonBossKey", RO_GANON_BOSS_KEY_VANILLA) != RO_GANON_BOSS_KEY_LACS_TOKENS &&
                CVarGetInteger("gRandomizeShuffleGanonBossKey", RO_GANON_BOSS_KEY_VANILLA) != RO_GANON_BOSS_KEY_LACS_VANILLA)
            ) && // LACS ganon boss key
            (locationIt.rc != RC_KAK_100_GOLD_SKULLTULA_REWARD || CVarGetInteger("gRandomizeShuffleGanonBossKey", RO_GANON_BOSS_KEY_VANILLA) != RO_GANON_BOSS_KEY_KAK_TOKENS) && // 100 skull reward ganon boss key
            (locationIt.rcType != RCTYPE_GF_KEY && locationIt.rc != RC_GF_GERUDO_MEMBERSHIP_CARD ||
                (CVarGetInteger("gRandomizeGerudoFortress", RO_GF_NORMAL) == RO_GF_OPEN && locationIt.rcType != RCTYPE_GF_KEY && locationIt.rc != RC_GF_GERUDO_MEMBERSHIP_CARD) ||
                (CVarGetInteger("gRandomizeGerudoFortress", RO_GF_NORMAL) == RO_GF_FAST &&
                    ((locationIt.rc == RC_GF_GERUDO_MEMBERSHIP_CARD && CVarGetInteger("gRandomizeShuffleGerudoToken", RO_GENERIC_NO) == RO_GENERIC_YES) ||
                    (locationIt.rc == RC_GF_NORTH_F1_CARPENTER && CVarGetInteger("gRandomizeGerudoKeys", RO_GERUDO_KEYS_VANILLA) != RO_GERUDO_KEYS_VANILLA))
                ) ||
                (CVarGetInteger("gRandomizeGerudoFortress", RO_GF_NORMAL) == RO_GF_NORMAL &&
                    ((locationIt.rc == RC_GF_GERUDO_MEMBERSHIP_CARD && CVarGetInteger("gRandomizeShuffleGerudoToken", RO_GENERIC_NO) == RO_GENERIC_YES) ||
                    (locationIt.rcType == RCTYPE_GF_KEY && CVarGetInteger("gRandomizeGerudoKeys", RO_GERUDO_KEYS_VANILLA) != RO_GERUDO_KEYS_VANILLA))
                )
            )
        );
    }
}
